/*
TASK: msweeper
LANG: C++
*/

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <stack>

#define fi(n) for(int i=0;i<n;i++)
#define fj(n) for(int j=0;j<n;j++)
#define fk(n) for(int k=0;k<n;k++)
#define fui(n) for(int i=n-1;i>=0;i--)
#define fuj(n) for(int j=n-1;j>=0;j--)
#define fuk(n) for(int k=n-1;k>=0;k--)
#define mp make_pair
#define pb push_back

#define mypi 3.1415926535897932384626433832795

using namespace std;

int n,r;

struct point
{
	int x,y;
};

vector <point> pts;
vector <int> idx;

bool operator<(const point &p1,const point &p2)
{
	double t1=atan2(p1.y-pts[0].y,p1.x-pts[0].x);
	double t2=atan2(p2.y-pts[0].y,p2.x-pts[0].x);
	if(t1<t2) return 1;
	if(t1==t2)
	{
		if(p1.y==p2.y)
		{
			return p1.x<p2.x;
		}
		return p1.y<p2.y;
	}
	return 0;
}

int os(point &p1,point &p2,point &p3)
{
	return p1.x*(p2.y-p3.y)+p2.x*(p3.y-p1.y)+p3.x*(p1.y-p2.y);
}

void read()
{
	int x1,y1;
	scanf("%d %d",&n,&r);
	pts.resize(n);
	point minp;
	minp.x=minp.y=30000;
	int mi;
	fi(n)
	{
		scanf("%d %d",&pts[i].x,&pts[i].y);
		if(pts[i].y<minp.y) {minp=pts[i];mi=i;}
		if(pts[i].y==minp.y&&pts[i].x>minp.x) {minp=pts[i];mi=i;}
	}
	minp=pts[mi];
	pts[mi]=pts[0];
	pts[0]=minp;
	sort(pts.begin()+1,pts.end());
	int fp,sp;
	stack <int> st;
	st.push(0);st.push(1);
	for(int i=2;i<n;i++)
	{
		sp=st.top();st.pop();
		fp=st.top();st.pop();
		if(os(pts[fp],pts[sp],pts[i])>=0)
		{
			st.push(fp);
			st.push(sp);
			st.push(i);
		}
		else
		{
			st.push(fp);
			i--;
		}
	}
	stack <int> inpov;
	while(st.empty()==0)
	{
		inpov.push(st.top());
		st.pop();
	}
	while(inpov.empty()==0)
	{
		idx.pb(inpov.top());
		inpov.pop();	
	}
}

void solve()
{
	double ans=0;
	int f,s,t;
	double ac;
	double ru;
	int len=idx.size();
	for(int i=0;i<len;i++)
	{
		f=(i-1+len)%len;
		s=i;
		t=(i+1+len)%len;	
		ans+=   sqrt((pts[idx[s]].x-pts[idx[t]].x)*(pts[idx[s]].x-pts[idx[t]].x)+
				(pts[idx[s]].y-pts[idx[t]].y)*(pts[idx[s]].y-pts[idx[t]].y));
	}
	ans+=2.0*mypi*r;
	printf("%lf\n",ans);
}

int main()
{
	read();
	solve();
	return 0;	
}
