/*
TASK: msweeper
LANG: C++
*/
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
using namespace std;

typedef pair<double, double> point;
#define x first
#define y second

point p[12000];
inline int less(point a, point b)
{
	if(a.x==0) return (b.x<a.x)||(b.x==a.x && a.y<b.y);
	double ang1=atan2(a.y, a.x), ang2=atan2(b.y, b.x);
	if(ang1<ang2) return 1;
	if(ang1==ang2) return a.x*a.x+a.y*a.y<b.x*b.x+b.y+b.y;
	return 0;
}

const double pi=3.1415926540;
const double eps=1e-9;

inline point operator+(point a, point b)
	{ point res; res.x=a.x+b.x; res.y=a.y+b.y; return res; }
inline point operator-(point a, point b)
	{ point res; res.x=a.x-b.x; res.y=a.y-b.y; return res; }
double vp(point a, point b) { return a.x*b.y-b.x*a.y; }

vector <point> obv;
int sz;

int main()
{
	unsigned n;
	double r;
	scanf("%d%lf", &n, &r);
	
	unsigned i, bottom=0;
	for(i=0; i<n; i++)
	{
		scanf("%lf%lf", &p[i].x, &p[i].y);
		if(p[i].y<p[bottom].y) bottom=i;
	}
	
	for(i=0; i<n; i++) if(i!=bottom) p[i]=p[i]-p[bottom];
	p[bottom].x=0; p[bottom].y=0;

	swap(p[0], p[bottom]); bottom=0;
	sort(p+1, p+n, less);
	
	obv.push_back(p[0]); sz=1;
	for(i=1; p[i].x==0 && p[i].y==0 && i<n; i++)
		{ obv.push_back(p[i]); sz++; }
	obv.push_back(p[i++]); sz++;
	
	for(; i<n; i++)
	{
		while( sz>2 && vp(obv[sz-1]-obv[sz-2], p[i]-obv[sz-1])<=eps )
			{ obv.pop_back(); sz--; }
		obv.push_back(p[i]); sz++;
	}
	
	double p=0;
	for(i=1; i<obv.size(); i++)
		p+=hypot(obv[i].x-obv[i-1].x, obv[i].y-obv[i-1].y);
	--i;
	p+=hypot(obv[i].x-obv[0].x, obv[i].y-obv[0].y);
	
	printf("%lf\n", p+2.0*pi*r);
	return 0;
}
