/*
TASK: boxes
LANG: C++
*/
#include <stdio.h>
#include <string>
using namespace std;

struct Vertex
{
       int u, next;
       Vertex(int _u, int _next):u(_u), next(_next){}
       Vertex(){}
} nodes[100000];
int table[100000], cnt;
int dominate[100000];

void add(int a, int b)
{
     nodes[cnt] = Vertex(b, table[a]);
     table[a] = cnt++;
}

int N;

int ans = 0;
int GRANDFATHER;
void dfs(int k)
{
     //printf("%d\n", k);
     for (int v = table[k]; v != -1; v = nodes[v].next)
     {
         int child = nodes[v].u;
         
         if (dominate[ child ] == -1) 
          dominate[ child ] = 0, dfs( child );
         else if (dominate[ child ] == 1 && child != GRANDFATHER) 
          dominate[ child ] = 0, ans--;
     }
}

void solve(int interr)
{
     //printf("begin\n");
     memset(dominate, -1, sizeof(dominate));
     memset(table, -1, sizeof(table));
     cnt = 0;
     ans = 0;
     scanf("%d", &N);
     for (int i = 0; i < N; i++)
     {
         int a;
         scanf("%d", &a); 
         a--;
         add(a, i);
     }
     
     for (int i = 0; i < N; i++) if (dominate[i] == -1) 
      GRANDFATHER = i, ans++, dominate[i] = 1, dfs(i);
     
     if (interr) printf(" ");
     printf("%d", ans);
     return;
}
int main()
{
    for (int qqq = 0; qqq < 2; qqq++) solve(qqq);
    printf("\n");
    return 0;
}
