/*
TASK: msweeper
LANG: C++
*/
#include <stdio.h>
#include <algorithm>
#include <math.h>
#define PI 3.1415926535897932384626433832795
using namespace std;

struct point
{
       int x, y;
       point(int _x, int _y):x(_x), y(_y){}
       point(){}
       bool operator<(point p) const
       {
            if (x != p.x) return x < p.x;
            return y < p.y;
       }
       point operator-(point p)
       {
             return point(x - p.x, y - p.y);
       }
       bool operator!=(point p)
       {
            return x != p.x || y != p.y;
       }
} P[10001], P2[10001];

int N, R;
point C[10001];
int cnt;

double dist(point p1, point p2)
{
       return sqrt((p1.x - p2.x)*(p1.x - p2.x) + (p1.y - p2.y)*(p1.y - p2.y));
}
int cross(point p1, point p2)
{
    return p1.x*p2.y - p1.y*p2.x;
}
int dot(point p1, point p2)
{
    return p1.x*p2.x + p1.y*p2.y;
}
void buildC()
{
     //sort(P, P + N);
     
     cnt = 2;
     C[0] = P[0];
     C[1] = P[1];
     for (int i = 2; i < N; i++) 
     {
         //printf("%d\n", i);
         while (cnt >= 2 && cross(P[i] - C[cnt-1], C[cnt-1] - C[cnt-2]) >= 0)
          cnt--;
         C[cnt++] = P[i];
     }
     //printf("%d\n", cnt);
     for (int i = N-2; i >= 0; i--)
     {
         while (cnt >= 2 && C[cnt-1] != P[N-1] && cross(P[i] - C[cnt-1], C[cnt-1] - C[cnt-2]) >= 0)
          cnt--;
         if (i != 0) C[cnt++] = P[i];
     }
}

double distK(point p1, point p2, point p3)
{
       int crossss = cross(p3 - p2, p1 - p2);
       int dotttt =  dot(p3 - p2, p1 - p2);
       double anngle = atan2(crossss, dotttt);
       if (anngle < 0) anngle += PI*2;
       anngle = PI - anngle;
       //printf("%d %d : %d %d : %d %d\n", p1.x, p1.y, p2.x, p2.y, p3.x, p3.y);
       //printf("%.3lf\n", anngle);
       return anngle*R;
}
int main()
{
    scanf("%d%d", &N, &R);

    for (int i = 0; i < N; i++) scanf("%d%d", &P2[i].x, &P2[i].y);
    
    int nnn = 0;
    sort(P2, P2 + N);
    for (int i = 1; i < N; i++) if (P2[i] != P2[i-1]) P[nnn++] = P2[i-1];
    P[nnn++] = P2[N-1];
    N = nnn;
    
    if (N == 1) {printf("%.6lf\n", PI*R*2); return 0; }
    if (N == 2) {printf("%.6lf\n", PI*R*2 + dist(P[0], P[1])*2); return 0; }
    
    buildC();    
    double D = 0;
    C[cnt] = C[0];
    //for (int i = 0; i < cnt; i++) printf("%d %d\n", C[i].x, C[i].y);
    if (cnt==2) { printf("%6lf\n", PI*R*2 + dist(C[0], C[1])*2); return 0; }
    
    for (int i = 0; i < cnt; i++) 
     D += dist(C[i], C[i+1]) + distK(C[(i-1+cnt)%cnt], C[i], C[i+1]);
    printf("%.6lf\n", D);
    return 0;
}
