/*
TASK: boxes
LANG: C++
*/
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 1 << 17;

int n;
int f[MAXN];
vector < int > a[MAXN];
int used[MAXN];

void read() {
	int i;
	
	scanf ( "%d" , &n );
	for (i = 1; i <= n; i++) a[i].clear();
	memset ( used , 0 , sizeof used );
	
	for (i = 1; i <= n; i++) {
		scanf ( "%d" , &f[i] );
		
		a[ f[i] ].push_back ( i );
	}
}

void dfs ( int x ) {
	used[x] = 1;
	int i;
	
	for (i = 0; i < (int)a[x].size(); i++)
		if ( !used[ a[x][i] ] )
			dfs ( a[x][i] );
}

void solve() {
	int ans = 0;
	int i , j;
	
	for (i = 1; i <= n; i++)
		if ( !used[i] ) {
			++ ans;
			j = i;
			
			while ( !used[j] ) {
				dfs ( j );
				j = f[j];
			}
		}
		
	printf ( "%d" , ans );
}

int main() {
	read();
	solve();
	printf ( " " );
	
	read();
	solve();
	printf ( "\n" );
	
	return 0;
}
