/*
TASK: msweeper
LANG: C++
*/
#include <cmath>
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 1 << 14;

int n , r;
pair < int , int > a[MAXN];
vector < pair < int , int > > f;

void read() {
	int i;
	int x , y;
	
	scanf ( "%d%d" , &n , &r );
	for (i = 1; i <= n; i++) {
		scanf ( "%d%d" , &x , &y );
		a[i] = make_pair ( x , y );
	}
}

long long cross ( pair < int , int > a , pair < int , int > b , pair < int , int > c ) {
	return (long long)(b.first - a.first) * (c.second - a.second) - (long long)(b.second - a.second) * (c.first - a.first);
}

double dist ( pair < int , int > a , pair < int , int > b ) {
	return sqrt ( (double)(a.first - b.first) * (double)(a.first - b.first) 
					+ (double)(a.second - b.second) * (double)(a.second - b.second) );
}

int cmp ( pair < int , int > q , pair < int , int > w ) {
	long long t = cross ( a[1] , q , w );
	
	if ( !t ) 
		return dist ( a[1] , q ) < dist ( a[1] , w );
	else
		return t > 0;
}

void solve() {
	int i;
	double ans = 0.;
	
	for (i = 2; i <= n; i++)
		if ( a[i].first < a[1].first || (a[i].first == a[1].first && a[i].second < a[1].second) )
			swap ( a[i] , a[1] );
	
	sort ( a + 2 , a + n + 1 , cmp );
	
	a[n + 1] = a[1];
	
	f.push_back ( a[1] );
	if ( n > 1 ) f.push_back ( a[2] );
	for (i = 3; i <= n + 1; i++) {
		while ( (int)f.size() > 1 && cross ( f[ (int)f.size() - 2 ] , f.back() , a[i] ) < 0 ) 
			f.pop_back();
		
		f.push_back ( a[i] );
	}
	
	for (i = 1; i < (int)f.size(); i++)  {
	//	printf ( "-- %d %d\n" , f[i].first , f[i].second );
		ans += dist ( f[i - 1] , f[i] );
	}
	
	printf ( "%lf\n" , ans + (double)r * 6.283185308 );
}

int main() {
	read();
	solve();
	
	return 0;
}
