/*
TASK: titanic
LANG: C++
*/
#include <set>
#include <ctime>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
using namespace std;

const int testingmode = 0;

const int MAXN = 1 << 10;
const int MIN_INT = 1 << 31;

int n , m;
int used[MAXN][MAXN];
int calc[MAXN][MAXN];

int tries;
int mat[MAXN][MAXN];
set < int > st;

void read() {
	scanf ( "%d%d" , &n , &m );
}

void gen() {
	int i , j;
	
	n = 10;
	m = 10;
	tries = 0;
	st.clear();
	
	for (i = 0; i < n; i++)
		for (j = 0; j < m; j++) {
			used[i][j] = 0;
			mat[i][j] = rand() % 1000;
			
			if ( rand() & 1 )
				mat[i][j] *= -1;
			
			if ( st.count ( mat[i][j] ) )
				-- j;
			st.insert ( mat[i][j] );
		}			
}

int ask ( int x , int y ) {
	if ( x < 1 || y < 1 || x > n || y > m ) return MIN_INT;
			
	-- x; -- y;	
	int ans;
	
	if ( used[x][y] )
		ans = calc[x][y];
	else {
		if ( testingmode ) {
			ans = mat[x][y];
			++ tries;
		} else {
			printf ( "0 %d %d\n" , x , y );
			scanf ( "%d" , &ans );
		}
		
		calc[x][y] = ans;
		used[x][y] = 1;
	}
	
	return ans;
}

void report ( int x , int y ) {
	-- x; -- y;
	
	if ( testingmode ) {
		printf ( "used %d tries\n" , tries );
		
		if ( (x < n - 1 && mat[x + 1][y] > mat[x][y]) || (x && mat[x - 1][y] > mat[x][y])
				   		|| (y < m - 1 && mat[x][y + 1] > mat[x][y]) || (y && mat[x][y - 1] > mat[x][y]) ) {
			printf ( "INCORRECT\n" );
			
			printf ( "%d %d\n" , n , m );
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < m; j++)
					printf ( "%d " , mat[i][j] );
				printf ( "\n" );
			}
			
			exit ( 0 );					
		}
		
	//	getchar();
	} else
		printf ( "1 %d %d\n" , x , y );
}

void solve() {
	int i , j;
	int x1 , y1 , x2 , y2;
	int x , y;
	int best;
	int bestx = -1 , besty = -1;
	int num , numx , numy;
	
	if ( n == 1 || m == 1 ) {
		best = MIN_INT;
		
		for (i = 1; i <= n; i++)
			for (j = 1; j <= m; j++)
				if ( ask ( i , j ) >= best ) {
					best = ask ( i , j );
					bestx = i;
					besty = j;
				}
		
		report ( bestx , besty );
		return ;
	}
	
	if ( n * m <= 3000 ) {
		//
	}
	
	num = numx = numy = -1;
	
	x1 = y1 = 1;
	x2 = n; y2 = m;
	
	x = 1 + n / 2;
	best = MIN_INT;
		
	for (j = 1; j <= m; j++) {
		if ( ask ( x , j ) >= best ) {
			best = ask ( x , j );
			bestx = x;
			besty = j;
		}
	}
		
	if ( ask ( x - 1 , besty ) <= best && ask ( x + 1 , besty ) <= best ) {
		report ( bestx , besty );
		return ;
	}
		
	if ( x == 1 ) {
		num = ask ( x + 1 , besty );
		numx = x + 1;
		numy = besty;
		
		x1 = x + 1;
	} else
		if ( x == n ) {
			num = ask ( x - 1 , besty );
			numx = x - 1;
			numy = besty;
				
			x2 = x - 1;
		} else {
			if ( ask ( x - 1 , besty ) > ask ( x + 1 , besty ) ) {
				num = ask ( x - 1 , besty );
				numx = x - 1;
				numy = besty;
				
				x2 = x - 1;
			} else {
				num = ask ( x + 1 , besty );
				numx = x + 1;
				numy = besty;
				
				x1 = x + 1;
			}
		}
	
	while ( x1 != x2 || y1 != y2 ) {
		if ( x2 - x1 > y2 - y1 ) {
			x = x1 + (x2 - x1) / 2;
			best = MIN_INT;
			
			for (j = y1; j <= y2; j++) {
				if ( ask ( x , j ) >= best ) {
					best = ask ( x , j );
					bestx = x;
					besty = j;
				}
			}
			
			if ( ask ( x - 1 , besty ) <= best && ask ( x + 1 , besty ) <= best )
				if ( ask ( x , besty - 1 ) <= best && ask ( x , besty + 1 ) <= best ) {
					report ( bestx , besty );
					return ;
				}
			
			if ( x == x1 ) {
				x1 ++;
			} else
				if ( x == x2 )
					x2 --;
				else {
					if ( best < num ) {
						if ( numx < x )
							x2 = x;
						else
							x1 = x;
					} else
						if ( ask ( x + 1 , besty ) > ask ( x - 1 , besty ) ) {
							num = ask ( x + 1 , besty );
							numx = x + 1;
							numy = besty;
								
							x1 = x + 1;
						} else {
							num = ask ( x - 1 , besty );
							numx = x - 1;
							numy = besty;
								
							x2 = x - 1;
						}
				}
		} else {
			y = y1 + (y2 - y1) / 2;
			best = MIN_INT;
				
			for (i = x1; i <= x2; i++) {
				if ( ask ( i , y ) >= best ) {
					best = ask ( i , y );
					bestx = i;
					besty = y;
				}
			}
			
			if ( ask ( bestx , y - 1 ) <= best && ask ( bestx , y + 1 ) <= best ) 
				if ( ask ( bestx - 1 , y ) <= best && ask ( bestx + 1 , y ) <= best ) {
					report ( bestx , besty );
					return ;
				}
			
			if ( y == y1 ) {
				y1 ++;
			} else
				if ( y == y2 )
					y2 --;
				else {
					if ( best < num ) {
						if ( numy < y )
							y2 = y;
						else
							y1 = y;
					} else
						if ( ask ( bestx , y + 1 ) > ask ( bestx , y - 1 ) ) {
							num = ask ( bestx , y + 1 );
							numx = bestx;
							numy = y + 1;
								
							y1 = y + 1;
						} else {
							num = ask ( bestx , y - 1 );
							numx = bestx;
							numy = y - 1;
								
							y2 = y - 1;
						}
				}
		}
	}
	
	report ( x1 , y1 );
}

int main() {
	if ( testingmode ) {
		srand ( time ( 0 ) );
		while ( 1 ) {
			gen();
			solve();
		}
	} else {
		read();
		solve();
	}
	
	return 0;
}
