/*
TASK: msweeper
LANG: C++
*/
#include <stdio.h>
#include <math.h>
#include <algorithm>
#include <vector>
#define x first
#define y second
#define MAXN (1 << 15)
#define INF (1 << 25)
using namespace std;
typedef pair<long long , long long> pii;

int n , r;
pii a[ MAXN ] , m;
double sol;
vector < pii > st;

inline int dist (pii a)
{
 return (a.x - m.x)*(a.x-m.x) + (a.y - m.y)*(a.y-m.y);
}

inline double dist1 (pii a , pii b)
{
 return sqrt ( (a.x - b.x)*(a.x-b.x) + (a.y - b.y)*(a.y-b.y) );
}


inline double tang (pii a)
{
 if ( a.y != m.y ) return (double) (a.x - m.x) / (double) (a.y - m.y);
 if ( a.x == m.x ) return -INF;
 return INF;
}

inline int cmp (pii a , pii b)
{
 if ( tang (a) == tang (b) ) return dist (a) > dist (b);
 return tang (a) < tang (b);
}

inline double vp (pii a, pii b, pii c , pii d)
{
 // a1*b2 - b1*a2
 return (b.x-a.x)*(d.y-c.y) - (d.x-c.x)*(b.y-a.y);
}

int main ()
{
 m = pii (INF , INF);
 scanf ("%d%d", &n, &r);
 
 for (int i=0; i < n; ++i)
  {
   scanf ("%d%d", &a[i].x, &a[i].y);
   if ( a[i].y < m.y ) m = a[i];
   if ( a[i].y == m.y && a[i].x > m.x ) m = a[i];
  }
 
 sort ( a , a + n , cmp );
 
 st.push_back ( a[0] );
 if ( n > 1 ) st.push_back ( a[1] );
 
 for (int i=2; i < n; ++i)
  {
   while ( 1 ) 
    if ( vp ( st[st.size() - 1] , st[st.size() - 2] , st[st.size() - 2] , a[i] ) < 0 ) st.pop_back ();
     else { st.push_back ( a[i] ); break; }
  }
 
 for (int i=0 ; i < st.size(); ++i)
  sol += dist1 ( st[i] , st[ (i + 1) % st.size() ] );
 
 sol += 2. * M_PI * (double) r;
 printf ("%.3lf\n", sol);
 return 0;
}
