/*
TASK: msweeper
LANG: C++
*/

#include <cstdio>
#include <cmath>
#include <algorithm>

const int MAX_N = 10000 + 5;

struct point
{
	int x, y;
	point(int _x = 0, int _y = 0) : x(_x), y(_y){};
};

point operator- (const point &a, const point &b)
{
	return point(a.x - b.x, a.y - b.y);
}

long long cp(const point &a, const point &b)
{
	return (long long)a.x * (long long)b.y - (long long)a.y * (long long)b.x;
}

long long cp(const point &a, const point &b, const point &c)
{
	return cp(b - a, c - a);
}

point by;
bool operator< (const point &a, const point &b)
{
	return cp( by, a, b ) >= 0;
}

double dist(const point &a, const point &b)
{
	return sqrt( double(a.x - b.x) * double(a.x - b.x) + double(a.y - b.y) * double(a.y - b.y) );
}

int N, R;
point p[MAX_N];
point st[MAX_N];
int top = 0;
bool used[MAX_N];
int first;
double res;
int main()
{
	scanf("%d %d", &N, &R);
	for(int i = 0; i < N; i ++)	scanf("%d %d", &p[i].x, &p[i].y);
	for(int i = 0; i < N; i ++)	if( p[i].x < p[first].x || (p[i].x == p[first].x && p[i].y == p[first].y) )	first = i;
	std :: swap(p[first], p[0]);
	by = p[0];
	std :: sort(p + 1, p + N);
//	for(int i = 0; i < N; i ++)	printf("%d %d\n", p[i].x, p[i].y);
	st[top ++] = p[0];
	st[top ++] = p[1];
	int cur = 2;
	while(cur < N)
	{
		while( top > 2 && cp( st[top - 2], st[top - 1], p[cur] ) < 0 )	top --;
		st[top ++] = p[cur ++];
	}
	st[top ++] = p[0];
	for(int i = 0; i + 1 < top; i ++)	res += dist(st[i], st[i + 1]);
	printf("%lf\n", res + 2 * M_PI * R);
	return 0;
}
