/*
TASK:msweeper
LANG:C++
*/
#include <iostream>
#include <vector>
#include <math.h>
using namespace std;
struct point
{
       int x,y;
};

point p[12000];
int N,R;
vector<point> h;

inline int CP(const point &p0,const point &p1,const point &p2)
{
    return (p1.x-p0.x)*(p2.y-p0.y) - (p2.x-p0.x)*(p1.y-p0.y);
}

inline double SP(const point &p0,const point &p1,const point &p2)
{
    return (p1.x-p0.x)*(p2.x-p0.x) + (p1.y-p0.y)*(p2.y-p0.y);
}

inline double dist2(const point &p1,const point &p2)
{
       return (p1.x-p2.x)*(p1.x-p2.x) + (p1.y-p2.y)*(p1.y-p2.y);
}

inline double dist(const point &p1,const point &p2)
{
       return sqrt(dist2(p1,p2));
}

bool cmp(const point &p1,const point &p2)
{
     return CP(p[1],p1,p2)>0;
}
bool cmp1(const point &p1,const point &p2)
{
     return p1.x*p1.x+p1.y*p1.y < p2.x*p2.x+p2.y*p2.y;
}
bool cmp2(const point &p1,const point &p2)
{
     return p1.x*p1.x+p1.y*p1.y > p2.x*p2.x+p2.y*p2.y;
}

void hull()
{
          h.push_back(p[1]);
          h.push_back(p[2]);
          h.push_back(p[3]);
          for(int i=4;i<=N+1;i++)
          {
                  while(h.size()>=2 && CP(h[h.size()-2],h[h.size()-1],p[i])<0) h.pop_back();
                  h.push_back(p[i]);
          }
          /*
          cout<<"hull:"<<endl;
          for(int i=0;i<h.size();i++)
                  cout<<h[i].x<<" "<<h[i].y<<endl;
     */
}
void perimeter()
{
     double P=0;
     for(int i=0;i<h.size()-1;i++)
             P+=dist(h[i],h[i+1]);
  //   cout<<P<<endl;

	 P+=2.0*M_PI*R;
	
     printf("%.6f\n",P);//cout<<P<<endl;
     
}
int main()
{
    scanf("%d %d",&N,&R);
    
    for(int i=1;i<=N;i++)
            scanf("%d %d",&p[i].x,&p[i].y);
     if(N==1) {printf("%.6f\n",2.0*M_PI*R);return 0;}
    int tmin=1;
    for(int i=2;i<=N;i++)
            if(p[i].x<p[tmin].x || (p[i].x==p[tmin].x && p[i].y<p[tmin].y) ) tmin=i;
            
    swap(p[1],p[tmin]);
    
    sort(p+2,p+N+1,cmp);
            
    p[N+1]=p[1];
    
    int t=3;
    while(CP(p[t-2],p[t-1],p[t])==0 && t<=N) t++;
    
    sort(p+2,p+t,cmp1);
    
    t=max(N-1,2);
    
    while(CP(p[t],p[t+1],p[t+2])==0 && t>2) t--;
    
    sort(p+t+1,p+N+1,cmp2);
    
    hull();
    
    perimeter();
	/*
        for(int i=1;i<=N;i++)
            cout<<p[i].x<<" "<<p[i].y<<endl;
		*/
}
