/*
TASK: msweeper
LANG: C++
*/
#include <iostream>
#include <cmath>
#include <algorithm>
using namespace std;
struct point
{
    double x, y;
};
const int MAXN = 10000;
int n = 0;
point mi, m[MAXN];
int top = 0;
point h[MAXN];
double d(point p1, point p2)
{
    return sqrt((double) pow((double) (p1.x - p2.x), 2.0) + pow((double) (p1.y - p2.y), 2.0));
}
bool compare(point p1, point p2)
{
    if((double) (p1.x - mi.x) / d(mi, p1) < (double) (p2.x - mi.x) / d(mi, p2))
        return false;
    return true;;
}
void graham_scan()
{
    int i, min_y = m[0].y, ind = 0;
    double a, b;
    for(i = 1; i < n; i++)
        if(min_y > m[i].y)
        {
            min_y = m[i].y;
            mi = m[i];
            ind = i;
        }
    h[top++] = mi;
    for(i = ind; i < n - 1; i++)
    {
        m[i].x = m[i + 1].x;
        m[i].y = m[i + 1].y;
    }
    sort(m, m + n - 1, compare);
    h[top++] = m[0];
    for(i = 2; i < n - 1; i++)
    {
        do
        {
            a = (double)((double) (h[top - 2].y - m[i].y) / (double) (h[top - 2].x - m[i].x));
            b = (double) (m[i].y - a * m[i].x);
            if(a * h[top - 1].x + b > h[top - 1].y)
                top--;
            else break;
        }
        while(1);
        h[top++] = m[i];
    }
}
double s()
{
    int c = 0, i;
    double temp = 0;
    point mh[MAXN];
    while(top != 0)
    {
        mh[c++] = h[top - 1];
        top--;
    }
    for(i = 0; i < c; i++)
        temp += d(mh[i - 1], mh[i]);
    temp += d(mh[c - 1], mh[0]);
    return temp;
}
int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    const double PI = 3.1415925435;
    int r, i;
    cin >> n >> r;
    for(i = 0; i < n; i++)
        cin >> m[i].x >> m[i].y;
    graham_scan();
    cout << (double) (s() + 2 * PI * r) << endl;
    //system("pause");
    return 0;
}
