/*
TASK:msweeper
LANG:C++
*/ 
#include <cstdlib>
#include <cstdio>
#include <cmath>

#define PI 3.141592

struct point
{
	int x, y;
};
struct vector
{
	int a, b;
};

int n, used[10002];
point points[10002];

inline int cross_sign(vector v1, vector v2)
{
	/*if (v1.a*v2.b - v1.b*v2.a >= 0)
		return 1;
	
	return -1;*/
	return (v1.a*v2.b - v1.b*v2.a >= 0) ? 1 : -1; 
}
int add_side(int v)
{
	int sign;
	vector v1, v2;
	
	for (int i = 0; i < n; i++)
	{
		if ((i == v) || (used[i])) continue;
		
		v1.a = points[i].x - points[v].x;
		v1.b = points[i].y - points[v].y;
			
		v2.a = points[0].x - points[v].x;
		v2.b = points[0].y - points[v].y;
		
		sign = cross_sign(v1, v2);
				
		for (int j = 1; j < n; j++)
		{
			if ((j == v) || (j == i)) continue;
			
			v2.a = points[j].x - points[v].x;
			v2.b = points[j].y - points[v].y;
			
			if (sign != cross_sign(v1, v2))
			{
				sign = 0;
				break;
			}
		}
		if (sign != 0)
		{
			used[i] = 1;
			return i;
		}
	}
	return -1;
}
int main()
{
	int r, minx = 100000, minxi;
	double sum = 0;
	scanf("%d %d", &n, &r);
	
	for (int i = 0; i < 10002; i++) used[i] = 0;
	
	for (int i = 0; i < n; i++)
	{
		scanf("%d %d", &points[i].x, &points[i].y);
		
		if (points[i].x < minx)
		{
			minx = points[i].x;
			minxi = i;
		}
	}
	
	int last = minxi;
	int current = add_side(last);
	while (current != -1)
	{
		sum += sqrt((points[last].x - points[current].x)*(points[last].x - points[current].x) + (points[last].y - points[current].y)*(points[last].y - points[current].y));
		last = current;
		current = add_side(last);
	}
	
	sum += PI*r*2;
	
	printf("%lf\n", sum);
	return 0;   
}
