/*
TASK: msweeper
LANG: C++
*/
#include<cstdio>
#include<cmath>
#include<algorithm>
using namespace std;
#define eps 1e-6
struct point
{
 double x,y;
};
int n,r;
point p[10002];
point u[10002];
void read_data()
{
 scanf("%d%d",&n,&r);
 int i;
 for(i=0;i<n;i++)
  {
   scanf("%lf%lf",&p[i].x,&p[i].y);
  }
}
bool cmp(point a,point b)
{
 return atan2(a.y-p[0].y,a.x-p[0].x)<=atan2(b.y-p[0].y,b.x-p[0].x);
}
double orient(point p1,point p2,point p3)
{
 double dx1=p3.x-p1.x;
 double dy1=p3.y-p1.y;
 double dx2=p2.x-p1.x;
 double dy2=p2.y-p1.y;
 return dx1*dy2-dy1*dx2;
}
double dist(point a,point b)
{
  return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
}
void solve()
{
 int mn=0;
int i;
for(i=1;i<n;i++)
  {
   if(p[i].x==p[mn].x)
    if(p[i].y<p[mn].y)
     mn=i;
   if(p[i].x<p[mn].x)
    mn=i;
  }
 swap(p[0],p[mn]);
 p[n]=p[0];
 sort(p+1,p+n,cmp);
 int m=2;
// freopen("test.out","w",stdout);
 for(i=3;i<=n;i++)
  {
  // printf("%d %lf %lf\n",i,p[i].x,p[i].y);
   while(orient(p[m-1],p[m],p[i])>=0)
     {

      m--;
     }
    //printf("left\n");
    m++;
    swap(p[i],p[m]);
  }
  double per=0;
  u[0]=p[m-1];
  for(i=1;i<=m;i++)
   u[i]=p[i-1];
  u[m+1]=p[0];
  //for(i=0;i<=m+1;i++)
  // printf("%lf %lf\n",u[i].x,u[i].y);
  for(i=1;i<=m;i++)
   {
    double kf;
    double df;
    double Af,Bf,Cf;
    Af=u[i+1].y-u[i].y;
    Bf=u[i].x-u[i+1].x;
    Cf=-(u[i].x*Af+u[i].y*Bf);
    kf=-Af/Bf;
    df=-Cf/Bf;
    double kb;
    double db;
    double Ab,Bb,Cb;
    Ab=u[i-1].y-u[i].y;
    Bb=u[i].x-u[i-1].x;
    Cb=-(u[i].x*Ab+u[i].y*Bb);
    kb=-Ab/Bb;
    db=-Cb/Bb;
    
    double k1=double(-1)/double(kf);
    double k2=double(-1)/double(kb);
    
    if(fabs(kf)<eps)
     k1=tan(M_PI/2);
    if(fabs(kb)<eps)
     k2=tan(M_PI/2);
    double ang=(atan(double(k1-k2)/double(1.0+k1*k2)));  
    if(ang<0)
     ang+=M_PI;
    if(fabs(k1*k2+1)<eps)
     ang=M_PI/2; 
    //printf("%lf\n",k1*k2+1);
    //printf("%lf\n%lf\n",abs(double(k1-k2)/double(1.0+k1*k2)),tan(ang));
    //double ka=abs((k1-k2)/(1+k1*k2));
    //double sina=sqrt((ka*ka)/(ka*ka+1));
    //double ang=asin(sina);
    //printf("res %lf %lf\n",ang*(180.0/M_PI),r*ang);
    per+=r*(ang);
    per+=dist(u[i-1],u[i]);
  }
  printf("%lf\n",per);
}
int main()
{
 read_data();
 solve();
 return 0;
}