/*
TASK: msweeper
LANG: C++
*/

#include <iostream>
#include <stack>
#include <cmath>
using namespace std;

#define D (double)
#define PI 3.141592653589

struct point
{
       double x, y;
       bool fl;
};

int N, nn = 0;
int m;
double R;
point p[10020], CH[10020];

double crossP( point a, point b, point c )
{
       return ( (b.x - a.x)*(c.y - a.y) - (b.y - a.y)*(c.x - a.x) );
}

double dist( point a, point b )
{
       return sqrt( (a.x - b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y) );
}

bool cmp( point a, point b )
{
     double pr = crossP( p[0], a, b );

     if ( a.fl == 0 )
        return false;
     if ( b.fl == 0 )
        return true;
     
     if ( pr != 0 )
        return pr > 0;
     
     if ( pr == 0 )
     {
          if ( dist( a, p[0] ) > dist( b, p[0] ) )
          {
               b.fl = 0;
               nn++;
               return true;
          }
          else
          {
               a.fl = 0;
               nn++;
               return false;
          }
     }
}

void graham()
{
    int i, j, k;
    stack<point> st;
    point a, b;
    
    p[0].x = 30000;
    p[0].y = 30000;
    m = 0;
    for ( i = 1; i <= N; i++ )
    {
        if ( p[i].y < p[m].y )
           m = i;
        else if ( ( p[i].y == p[m].y ) && ( p[i].x < p[m].x ) )
             m = i;
    }
    
    p[0] = p[m];
    swap( p[m], p[N] );
    N--;
    
    sort( &p[1], &p[N+1], cmp );
    
    st.push( p[0] );
    st.push( p[1] );
    k = 2;
    while ( ( crossP( p[0], p[1], p[k] ) == 0 ) && ( k <= N ) )
          k++;
    if ( k <= N )
       st.push( p[k] );
    k++;
    
    for ( i = k; i <= N; i++ )
    {
        if ( crossP( p[0], p[i], p[i-1] ) == 0 )
           continue;
        a = st.top();
        st.pop();
        b = st.top();
        while ( ( crossP( st.top(), a, p[i] ) < 0 ) )
        {
              a = st.top();
              st.pop();
        }
        if ( crossP( st.top(), a, p[i] ) == 0 )
        {
            st.push( p[i] );
            continue;
        }
        st.push( a );
        st.push( p[i] );
    }
    
    m = 0;
    while ( !st.empty() )
    {
          CH[++m] = st.top();
          st.pop();
    }
}

int main()
{
    int i, j, k;
    double Per;
    
    cin >> N >> R;
    for ( i = 1; i <= N; i++ )
    {
        scanf( "%d%d", &j, &k );
        p[i].x = j;
        p[i].y = k;
        p[i].fl = 1;
    }
    
    if ( N == 1 )
    {
         Per = 2*PI*R;
         printf( "%.5lf\n", Per );
         return 0;
    }
    
    if ( N == 2 )
    {
         Per = dist( p[1], p[2] ) + 2*PI*R;
         printf( "%.5lf\n", Per );
         return 0;
    }
    
    graham();

    if ( m == 2 )
    {
         Per = dist( CH[1], CH[2] ) + 2*PI*R;
         printf( "%.5lf\n", Per );
         return 0;
    }
    
    Per = 0;
    for ( i = 1; i < m; i++ )
    {
        Per = Per + dist( CH[i], CH[i+1] );
    }
    Per = Per + dist( CH[m], CH[1] );
    
    Per = Per + 2*PI*R;
    printf( "%.5lf\n", Per );
    
    return 0;
}
