/*
TASK: titanic
LANG: C++
*/

#include <iostream>
#include <queue>
using namespace std;

#define fi first
#define se second

typedef pair<int,int> pii;

int n, m;
int t[1024][1024];
bool inq[1024][1024];

int query( int x, int y )
{
    if ( ( x < 0 ) || ( x >= n ) || ( y < 0 ) || ( y >= m ) )
       return INT_MIN;
    if ( t[x][y] != INT_MIN )
       return t[x][y];
    printf( "0 %d %d\n", x, y );
    scanf( "%d", &t[x][y] );
    return t[x][y];
}

void BFS()
{
     int i, j, k;
     pii a, b;
     queue<pii> q;
     memset( inq, 0, sizeof( inq ) );
     
     j = query( 0, 0 );
     q.push( make_pair( 0, 0 ) );
     q.push( make_pair( n-1, m-1 ) );
     q.push( make_pair( 0, m-1 ) );
     q.push( make_pair( n-1, 0 ) );
     inq[0][0] = 1;
     
     while ( 1 )
     {
           a = q.front();
           q.pop();
           
           b = a;
           j = query( a.fi, a.se );
           if ( ( j > query( a.fi, a.se + 1 ) ) && ( j > query( a.fi, a.se - 1 ) ) && ( j > query( a.fi-1, a.se ) ) && ( j > query( a.fi+1, a.se ) ) )
           {
                printf( "1 %d %d\n", a.fi, a.se );
                return;
           }
           
           if ( inq[a.fi][a.se+1] == 0 )
           {
                inq[a.fi][a.se+1] = 1;
                q.push( make_pair( a.fi, a.se+1 ) );
           }
           if ( inq[a.fi][a.se-1] == 0 )
           {
                inq[a.fi][a.se-1] = 1;
                q.push( make_pair( a.fi, a.se-1 ) );
           }
           if ( inq[a.fi+1][a.se] == 0 )
           {
                inq[a.fi+1][a.se] = 1;
                q.push( make_pair( a.fi+1, a.se ) );
           }
           if ( inq[a.fi-1][a.se] == 0 )
           {
                inq[a.fi-1][a.se] = 1;
                q.push( make_pair( a.fi - 1, a.se ) );
           }
     }
}

int main()
{
    int i, j, k;

    cin >> n >> m;
    
    for ( i = 0; i <= n+1; i++ )
    {
        for ( j = 0; j <= m+1; j++ )
            t[i][j] = INT_MIN;
    }

    BFS();
    return 0;
}
