/*
TASK: msweeper
LANG: C++
*/

#include <cstdio>
#include <utility>
#include <algorithm>
#include <cmath>

using namespace std;

struct mine {
	int x, y;
} mines[16384];
int n, r, minmine = 0;

int tarea(int m1, int m2, int m3) {
	return mines[m1].x*(mines[m2].y-mines[m3].y) +
			mines[m2].x*(mines[m3].y-mines[m1].y) +
			mines[m3].x*(mines[m1].y-mines[m2].y);
}
bool sortcmp(const int& a, const int& b) {
	return tarea(minmine, a, b) > 0;
}

int msorted[16384];
int mstack[16384], mstackn;
void graham() {
	for(int i = 0; i < n; ++i)
		msorted[i] = i;
	swap(msorted[0], msorted[minmine]);
	sort(msorted+1, msorted+n, sortcmp);

	mstack[0] = msorted[0];
	mstack[1] = msorted[1];
	mstackn = 2;
	for(int i = 2; i < n; ++i) {
		while(tarea(mstack[mstackn-2], mstack[mstackn-1], msorted[i]) < 0) --mstackn;
		mstack[mstackn++] = msorted[i];
	}
	while(tarea(mstack[mstackn-2], mstack[mstackn-1], mstack[0]) < 0) --mstackn;

	double p = 0;
	for(int i = 0; i < mstackn; ++i) {
		int dx = mines[mstack[i]].x - mines[mstack[(i+1)%mstackn]].x;
		int dy = mines[mstack[i]].y - mines[mstack[(i+1)%mstackn]].y;
		p += sqrt(dx*dx+dy*dy);
	}
	printf("%.10lf\n", p+2*M_PI*r);
}

int main() {
	scanf("%d%d", &n, &r);
	for(int i = 0; i < n; ++i) {
		scanf("%d%d", &mines[i].x, &mines[i].y);
		if(mines[minmine].y > mines[i].y) {
			minmine = i;
		} else if(mines[minmine].y == mines[i].y && mines[minmine].x > mines[i].x) {
			minmine = i;
		}
	}
	if(n == 0) {
		printf("0\n");
		return 0;
	}
	if(n == 1) {
		printf("%.10lf\n", 2*M_PI*r);
		return 0;
	}
	graham();
	return 0;
}
