/*
LANG: C++
TASK: titanic
*/

#include <cstdio>
#include <cstdlib>
#include <queue>

using namespace std;

struct point {
	int x, y;
	point() { }
	point(int _x, int _y) : x(_x), y(_y) { }

	point operator+(const point& p) const {
		return point(x+p.x, y+p.y);
	}
};


bool q[1024][1024];
int val[1024][1024];
#define VAL(p) (val[p.x][p.y])
bool vis[1024][1024];
#define VIS(p) (vis[p.x][p.y])
int w, h;

inline bool in(point p) {
	return p.x >= 0 && p.y >= 0 && p.x < w && p.y < h;
}
int max(int a, int b, int c, int d) {
	if(b > a) a = b;
	if(c > a) a = c;
	if(d > a) a = d;
	return a;
}
point d[4]  = {
	point(-1, 0),
	point(1, 0),
	point(0, -1),
	point(0, 1)
};
inline bool check(point p) {
	if(!in(p)) return false;
	if(!q[p.x][p.y]) return false;

	point n;
	for(int i = 0; i < 4; ++i) {
		n = p+d[i];

		if(!in(n))
			continue;
		if(!q[n.x][n.y])
			return false;
		if(VAL(p) <= VAL(n))
			return false;
	}

	return true;
}
inline void ask(point p) {
	printf("0 %d %d\n", p.x, p.y);
	int h;
	scanf("%d", &h);
	q[p.x][p.y] = 1;
	val[p.x][p.y] = h;
}
inline void ask_all(point p) {
	if(!q[p.x][p.y])
		ask(p);

	point n;
	for(int i = 0; i < 4; ++i) {
		n = p+d[i];

		if(!in(n))
			continue;
		if(q[n.x][n.y])
			continue;

		ask(n);
	}
}

struct cmp {
	bool operator() (const point& a, const point& b) {
		return VAL(a) < VAL(b);
	}
};

priority_queue<point, vector<point>, cmp> pq;

int main() {
	scanf("%d%d", &w, &h);

	pq.push(point(w/2, h/2));

	point c, n;
	int nx, ny;

	while(true) {
		c = pq.top(); pq.pop();
		//printf("got %d %d\n", c.x, c.y);

		ask_all(c);

		if(check(c)) {
			printf("1 %d %d\n", c.x, c.y);
			return 0;
		}

		int mh = max(val[c.x-1][c.y], val[c.x+1][c.y], val[c.x][c.y-1], val[c.x][c.y+1]);

		for(int i = 0; i < 4; ++i) {
			n = c+d[i];
			if(in(n) && VAL(n) == mh && !VIS(n)) {
				pq.push(n);
				VIS(n) = true;
			}
		}
	}
}
