
/*
TASK: msweeper
LANG: C++
*/

#include <cmath>
#include <cstdio>
#include <algorithm>
using namespace std;

const int MAX_N = 16384;

struct pnt {
    int x, y;

    pnt(int x = 0, int y = 0) {
        this->x = x;
        this->y = y;
    }
};

inline long long area(pnt a, pnt b, pnt c) {
    return a.x * (0LL + b.y - c.y) + b.x * (0LL + c.y - a.y) + c.x * (0LL + a.y - b.y);
}

int N, R;
pnt p[MAX_N];

struct cmp_angle {
    inline bool operator()(const pnt &a, const pnt &b) const {
        return area(p[0], b, a) < 0;
    }
};

void read() {
    scanf("%d %d", &N, &R);
    for (int i = 0; i < N; ++i)
        scanf("%d %d", &p[i].x, &p[i].y);
}

inline double dist(pnt &a, pnt &b) {
    return sqrt((a.x - b.x + 0.0) * (a.x - b.x + 0.0) + (a.y - b.y + 0.0) * (a.y - b.y + 0.0));
}

void solve() {
    if (N == 1) {
        printf("%.10lf\n", 2.0 * M_PI * R);
        return;
    } else if (N == 2) {
        printf("%.10lf\n", 2.0 * M_PI * R + dist(p[0], p[1]) * 2.0);
        return;
    }
    int bottom = 0;
    for (int i = 1; i < N; ++i)
        if (p[i].y < p[bottom].y || p[i].y == p[bottom].y && p[i].x < p[bottom].x) {
            bottom = i;
        }
    swap(p[0], p[bottom]);
    sort(p + 1, p + N, cmp_angle());
//    for (int i = 0; i < N; ++i)
//        printf("(%d, %d)\n", p[i].x, p[i].y);

    static int stk[MAX_N];
    int sp = 0;
    for (int i = 0; i < N; ++i) {
        // might be wrong
        while (sp >= 2 && area(p[stk[sp - 2]], p[stk[sp - 1]], p[i]) < 0)
            --sp;
        stk[sp++] = i;
    }
//    puts("");
//    for (int i = 0; i < sp; ++i)
//        printf("(%d, %d)\n", p[stk[i]].x, p[stk[i]].y);

    double res = 0.0;
    for (int i = 0; i < sp; ++i)
        res += dist(p[stk[i]], p[stk[(i + 1) % sp]]);
    printf("%.10lf\n", res + 2.0 * M_PI * R);
}

int main() {
    read();
    solve();
    return 0;
}
