
/*
TASK: titanic
LANG: C++
*/

#include <cstdio>
#include <algorithm>
using namespace std;

const int MAX_N = 1000 + 5;
const int MAX_M = 1000 + 5;

const int dx[] = {-1, 1, 0, 0};
const int dy[] = {0, 0, -1, 1};

int N, M, K = 0;
bool done[MAX_N][MAX_M];
int cache[MAX_N][MAX_M];

inline int query(int x, int y) {
    if (done[x][y])
        return cache[x][y];
//    ++K;
//    if (K % 100 == 0)
//        fprintf(stderr, "%d\n", K);
    done[x][y] = true;
    printf("0 %d %d\n", x, y);
    fflush(stdout);
    scanf("%d", &cache[x][y]);
    return cache[x][y];
}

inline bool ok(int x, int y) {
    int z = query(x, y);
    for (int i = 0; i < 4; ++i) {
        int nx = x + dx[i];
        int ny = y + dy[i];
        if (nx < 0 || nx >= N || ny < 0 || ny >= M) {
            continue;
        }
//        fprintf(stderr, "(%d, %d) is neighbour!\n", nx, ny);
        if (query(nx, ny) > z)
            return false;
    }
    return true;
}

inline int random(int a, int b) {
    if (a == b)
        return a;
    return a + rand() % (b - a + 1);
}

int main() {
    scanf("%d %d", &N, &M);

    int x = 0, y = 0;
    srand(666); // Specially for momtchil.    
    
    // Check some random 50 points to get a good start point.
    for (int i = 0; i < 50; ++i) {
        int cx = random(0, N - 1);
        int cy = random(0, M - 1);
        if (ok(cx, cy)) {
            x = cx;
            y = cy;
            break;
        }
        if (query(cx, cy) > query(x, y)) {
            x = cx;
            y = cy;
        }
    }

    for (int i = 0; i < N; ++i) {
        int j = random(0, M - 1);
        if (query(i, j) > query(x, y)) {
            x = i;
            y = j;
        }
    }
/*
    // Find the maximum over the row and column of this point. (this one is important)
    // Cases such a spiral can easily break it otherwise.
    if (!ok(x, y)) {
        //int best = query(x, y);
        int nx = x;
        int ny = y;
        for (int i = 0; i < N; ++i)
            if (query(i, y) > query(nx, ny)) {
                nx = i;
                ny = y;
            }
        for (int i = 0; i < M; ++i)
            if (query(x, i) > query(nx, ny)) {
                nx = x;
                ny = i;
            }
        x = nx;
        y = ny;
    }
    */
    // Always go to the maximum of the neighbours. (if no such one -- we have a solution)
    while (!ok(x, y)) {
        int best = query(x, y);
        int nx, ny;
        for (int i = 0; i < 4; ++i) {
            int cx = x + dx[i];
            int cy = y + dy[i];
            if (cx < 0 || cx >= N || cy < 0 || cy >= M)
                continue;
            if (query(cx, cy) > best) {
                best = query(cx, cy);
                nx = cx;
                ny = cy;
            }
        }
        x = nx;
        y = ny;
    }
    printf("1 %d %d\n", x, y);
    fflush(stdout);
    return 0;
}
