/*
TASK: msweeper
LANG: C++
*/

#include <algorithm>
#include <cstdio>
#include <vector>
#include <cmath>

using namespace std;

struct point
{
 int x,y;
 point() {}
 point(int _x,int _y)
 { x=_x; y=_y; }
};

bool comp(point a,point b)
{ return (a.x<b.x || (a.x==b.x && a.y<b.y)); }

int n,r;
point inp[10003];
point convex[10003];
double p;

void init()
{
 int i;    
 scanf("%d %d",&n,&r); p=2*M_PI*r;
 for(i=0;i<n;i++)
   scanf("%d %d",&inp[i].x,&inp[i].y);    
}

int S(point a,point b,point c)
{ return (b.x-a.x)*(c.y-a.y)-(c.x-a.x)*(b.y-a.y); }

double dist(point a,point b)
{ return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y)); }

int convexHull()
{
 sort(inp,inp+n,comp);
 int sz=0,i,t;
 for(i=0;i<n;i++)
  {
   while(sz>=2 && S(convex[sz-2],convex[sz-1],inp[i])>=0) { sz--; }
   convex[sz++]=inp[i];
  }    
 t=sz;
 for(i=n-2;i>=0;i--)
  {
   while(sz>t && S(convex[sz-2],convex[sz-1],inp[i])>=0) { sz--; }
   convex[sz++]=inp[i];    
  } 
 sz--;
 return sz;
}

int main()
{
 init();
 int to=convexHull()-1;
 
 int i;
 double perimeter=0.0;
 
 for(i=0;i<to;i++)
   perimeter+=dist(convex[i],convex[i+1]);
 perimeter+=dist(convex[0],convex[to]); 

 printf("%.5f\n",perimeter+p);

 return 0;
}
