/*
TASK:boxes
LANG:C++
*/

#include <iostream>
#include <vector>
using namespace std;

const int max_n = (1<<17);

int p[max_n], r[max_n];
vector<int> G[max_n];

bool root[max_n];
int Find(int v){
	if(p[p[v]] != p[v]) p[v] = Find(p[v]);
	return p[v];	
}

void Union(int v1, int v2){
	v1 = Find(v1);
	v2 = Find(v2);
	if(v1 != v2){
		if(r[v1] < r[v2]) p[v1] = v2;
		if(r[v1] > r[v2]) p[v2] = v1;
		//else
		r[v1]++;
		p[v2] = v1;
	}	
}

void doit(){
	int i, j, n, t, s, res = 0;
	

	
	//read
	scanf("%d", &n);
	// init G after the first call
	for(i = 1; i <= n; i++) G[i].clear();
	
	for(i = 1; i <= n; i++){
		scanf("%d", &t);
		G[t].push_back(i);
	}
	
	//init uf
	for(i = 1; i <= n; i++){
		p[i] = i;
		r[i] = 0;
		root[i] = false;
	}
	
	// union step
	for(i = 1; i <= n; i++){
		s = G[i].size();
		for(j = 0; j < s; j++)
			Union(i, G[i][j]);	
	}
	
	
	// find step
	for(i = 1; i <= n; i++){
		//cout << "F:" << i << ":" << Find(i) << endl;
		root[Find(i)] = true;
	}
		
	
	
	for(i = 1; i <= n; i++)
		if(root[i]) res++;
	
	printf("%d", res);
	
}

int main(){
	doit();
	printf(" "); 
	doit();	
	printf("\n");
	return 0;
}
