/*
TASK:msweeper
LANG:C++
*/

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <math.h>

using namespace std;

const int max_n = (1<<14);

const double Pi = 3.1415926535897932384626433832795;
struct pt{
	int x, y;	
};

pt p[max_n];
int ps[max_n], pl;
int pc[max_n], pcl = 0;

//DUMBASS OPTIMISATION
int pt[max_n], ptl = 0;

struct cmpl{
	bool operator()(const int& a, const int& b){
		//return p[a].x < p[b].x || (p[a].x == p[b].x && p[a].y < p[b].y) || (p[a].x == p[b].x && p[a].y == p[b].y && a < b);			
		return p[a].x < p[b].x || ( p[a].x == p[b].x && (p[a].y < p[b].y || (p[a].y == p[b].y && a < b) ) );
	}
};

cmpl tcmpl;

#define CROSS(A, B, C) ((p[B].x - p[A].x)*(p[C].y - p[A].y) - (p[B].y - p[A].y)*(p[C].x - p[A].x))
#define DIST(A, B) sqrt(double((p[A].x - p[B].x)*(p[A].x - p[B].x) + (p[A].y - p[B].y)*(p[A].y - p[B].y)))

//Dumbass optimisation
#define EQUAL(A, B) ((p[A].x == p[B].x) && (p[A].y == p[B].y))

int main(){
	int i, r, X;
	double len;
	scanf("%d%d", &pl, &r);
	cout << setprecision(13);
	
	len = 2.0*Pi*double(r);
	
	for(i = 0; i < pl; i++){
		scanf("%d%d", &p[i].x, &p[i].y);	
		ps[i] = i;
	}
	
	if(pl == 1){
		// 2Pir
		cout << len << endl;
	}else{
		sort(ps, ps + pl, tcmpl);
		
		// DUMBASS OPTIMISATION - remove points in the rectangle
		int L = 0, R = 0, U = 0, D = 0;
		
		for(i = 0; i < pl; i++){
			if(p[L].x > p[i].x) L = i;
			if(p[R].x < p[i].x) R = i;
			if(p[D].y > p[i].y) D = i;
			if(p[U].y < p[i].y) U = i; 	
		}
		
		// if the points are different - make the optimisaiton
		if(!EQUAL(L,R) && !EQUAL(L,U) && !EQUAL(L,D) && !EQUAL(R,U) && !EQUAL(R,D) && !EQUAL(U,D)){
			for(i = 0; i < pl; i++){
				if(
					(ps[i] != L && ps[i] != R && ps[i] != U && ps[i] != D) &&
					CROSS(D,L,ps[i]) <= 0 &&
					CROSS(L,U,ps[i]) <= 0 &&
					CROSS(U,R,ps[i]) <= 0 &&
					CROSS(R,D,ps[i]) <= 0	
				){
					;	
				}else{
					pt[ptl++] = ps[i];	
				}
						
			}
				
			for(i = 0; i < ptl; i++)
				ps[i] = pt[i];
			pl = ptl;
		}
		
		// END OF DUMBASS OPTIMISATION
		//cout << "New points:" << pl << endl;
		//for(i = 0; i < pl; i++)
		//	cout << ps[i] << ' ';
		//cout << endl;
		pc[pcl++] = ps[0];
		pc[pcl++] = ps[1];
		
		for(i = 2; i < pl; i++){
			pc[pcl++] = ps[i];
			while(pcl > 2 && CROSS(pc[pcl-3], pc[pcl-2], pc[pcl-1]) >= 0){
				pc[pcl-2] = pc[pcl-1];
				pcl--;	
			}
		}
		
		X = pcl - 1;
		pc[pcl++] = ps[pl-2];

		for(i = pl - 3; i >= 0; i--){
			pc[pcl++] = ps[i];
			
			while(pcl > 2 + X && CROSS(pc[pcl-3], pc[pcl-2], pc[pcl-1]) >= 0){
				pc[pcl-2] = pc[pcl-1];
				pcl--;	
			}	
		}
		
		for(i = 0; i < pcl-1; i++)
		len += DIST(pc[i], pc[i+1]);
		
		//printf("%.3f\n", float(len));
		cout << len << endl;
	}
	
	
	return 0;
}
