/*
TASK: boxes
LANG: C++
*/

#include <algorithm>
#include <vector>
using namespace std;

#define child						first
#define node						second

typedef pair<int, int> PII;

const int MAX_N = 1 << 17;

int N, C, ans;
int used[MAX_N], size[MAX_N];
vector<int> children[MAX_N], parents[MAX_N];

void Read()
{
	scanf("%d", & N);
	
	for(int i = 0; i < MAX_N; i ++)
	{
		children[i].clear();
		parents[i].clear();
	}
	
	for(int i = 0, x; i < N; i ++)
	{
		scanf("%d", & x);
		
		children[x - 1].push_back(i);
		parents[i].push_back(x - 1);
	}
}

void DFS_1(int n)
{
	used[n] = C;
	
	for(int i = 0; i < children[n].size(); i ++)
	{
		if(!used[children[n][i]])
		{
			DFS_1(children[n][i]);
		}
	}
}

void DFS(int n)
{
	DFS_1(n);
	
	for(int i = 0; i < parents[n].size(); i ++)
	{
	int n1 = parents[n][i];
		
		if(!used[n1])
		{
			DFS(n1);
		}
	}
}

void Solve()
{
	C = 0;
	
	for(int i = 0; i < N; i ++)
	{
		used[i] = 0;
	}
	
	for(int i = 0; i < N; i ++)
	{
		if(!used[i])
		{
			C ++;
			
			DFS(i);
		}
	}
	
	ans = C;
}

int main()
{
	for(int iter = 0; iter < 2; iter ++)
	{
		Read();
		
		Solve();
		
		if(iter == 0) printf("%d ", ans);
		else printf("%d\n", ans);
		
//		fprintf(stderr, "Try Answer: %d\n", ans);
//		system("pause");
	}
	
//	fprintf(stderr, "BOXES RUN TIME: %.5lf\n", double(clock()) / double(CLOCKS_PER_SEC));
	
	
	return 0;
}

/*
TEST 0:
4
2 1 2 4
3
3 3 3
Answer: 2 1


*/
