/*
TASK: msweeper
LANG: C++
*/

#include <algorithm>
#include <complex>

#define DEBUG						PRINT SOME SHIT!!!!!
#undef DEBUG

#define X							real()
#define Y							imag()

#define dot(a, b)					real(conj(a) * (b))
#define cross(a, b)					imag(conj(a) * (b))
#define length(a)					sqrt(dot(a, a))
#define area2(a, b, c)				cross(b - a, c - a)
#define rotate_by(p, a, r)			((p - a) * exp(point(0.0, r)) + a)

#define EQ(a, b)					(fabs(a - b) < EPS)
#define EQ_P(a, b)					(EQ(a.X, b.X) && EQ(a.Y, b.Y))
#define LESS(a, b)					(a < b + EPS)

typedef std :: complex<double> point;

const int MAX_N = 1 << 15;
const double EPS = 1e-9;
const double Pi = acos(- 1.0);

int N, C;
double R, ans;
point p[MAX_N], c[MAX_N], t[MAX_N][2];


void Read()
{
	scanf("%d %lf", & N, & R);
	
	for(int i = 0; i < N; i ++)
		scanf("%lf %lf", & p[i].X, & p[i].Y);
}

bool cmp_x(const point & a, const point & b)
{
	if(EQ(a.X, b.X)) return LESS(b.Y, a.Y);
	
	return LESS(a.X, b.X);
}

void Convex_Hull()
{
int T = 0;
point temp[MAX_N];
	
//	c[C ++] = p[0];
	
	for(int i = 0; i < N; i ++)
	{
		while(2 <= C && (LESS(0.0, area2(c[C - 2], c[C - 1], p[i])) && !EQ(0.0, area2(c[C - 2], c[C - 1], p[i]))))
		{
			C --;
		}
		
		c[C ++] = p[i];
	}
	
#ifdef DEBUG
	fprintf(stderr, "CONVEX HULL:\n");
	for(int i = 0; i < C; i ++)
		fprintf(stderr, "(%.3lf, %.3lf)\n", c[i].X, c[i].Y);
	system("pause");
#endif
	
	for(int i = N - 1; 0 <= i; i --)
	{
//		fprintf(stderr, "(%.3lf, %.3lf)\n", p[i].X, p[i].Y);
		
		while(2 <= C && (LESS(0.0, area2(c[C - 2], c[C - 1], p[i])) && !EQ(0.0, area2(c[C - 2], c[C - 1], p[i]))))
		{
//			fprintf(stderr, "%.5lf\n", area2(c[C - 2], c[C - 1], p[i]));
			
			C --;
		}
		
		c[C ++] = p[i];
	}
	
	
#ifdef DEBUG
	fprintf(stderr, "CONVEX HULL:\n");
	for(int i = 0; i < C; i ++)
		fprintf(stderr, "(%.3lf, %.3lf)\n", c[i].X, c[i].Y);
	system("pause");
#endif
	
	temp[T ++] = c[0];
	for(int i = 1; i < C; i ++)
		if(!EQ_P(temp[T - 1], c[i]))
			temp[T ++] = c[i];
	
	C = T;
	for(int i = 0; i < T; i ++)
		c[i] = temp[i];
	
	if(EQ_P(c[0], c[C - 1]))
		C --;
	
#ifdef DEBUG
	fprintf(stderr, "CONVEX HULL:\n");
	for(int i = 0; i < C; i ++)
		fprintf(stderr, "(%.3lf, %.3lf)\n", c[i].X, c[i].Y);
	system("pause");
#endif
}

double degree(const double & rad)
{
	return (rad / (2.0 * Pi)) * 360.0;
}

double Arg(const point & p)
{
	if(LESS(arg(p), 0.0)) return (2.0 * Pi + arg(p));
	
	return arg(p);
}

void Solve()
{
int T = 0;
point t1[MAX_N];
	
	if(N == 1)
	{
		printf("%.9lf\n", 2.0 * Pi * R);
		exit(0);
	}
	
	if(N == 2)
	{
		printf("%.9lf\n", 2.0 * Pi * R + 2.0 * length(p[0] - p[1]));
		exit(0);
	}
	
	sort(p, p + N, cmp_x);
	
	t1[T ++] = p[0];
	for(int i = 1; i < N; i ++)
		if(!EQ_P(t1[T - 1], p[i]))
			t1[T ++] = p[i];
	
	N = T;
	for(int i = 0; i < T; i ++)
		p[i] = t1[i];
	
	
	
	Convex_Hull();
	
	for(int i = 0; i < C; i ++)
	{
	point temp = rotate_by(c[(i + 1) % C] - c[i], point(0.0, 0.0), Pi * 0.5);
		
		temp *= R / length(temp);
		
		temp += c[i];
		
		t[i][1] = temp;
		
		temp = rotate_by(c[i] - c[(i + 1) % C], point(0.0, 0.0), - Pi * 0.5);
		
		temp *= R / length(temp);
		
		temp += c[(i + 1) % C];
		
		t[(i + 1) % C][0] = temp;
	}
	
#ifdef DEBUG
	fprintf(stderr, "Temp Points:\n");
	for(int i = 0; i < C; i ++)
		fprintf(stderr, "(%.3lf, %.3lf)  (%.3lf, %.3lf)\n", t[i][0].X, t[i][0].Y, t[i][1].X, t[i][1].Y);
	system("pause");
#endif
	
	
	for(int i = 0; i < C; i ++)
	{
		ans += length(c[i] - c[(i + 1) % C]);
		
		if(EQ(0.0, arg(t[i][1] - c[i])) || LESS(0.0, arg(t[i][1] - c[i])))
		{
			ans += (Arg(t[i][0] - c[i]) - arg(t[i][1] - c[i])) * R;
		}
		else
		{
			ans += fabs(arg(t[i][0] - c[i]) - arg(t[i][1] - c[i])) * R;
		}
	}
}

void Write()
{
	printf("%.9lf\n", ans);
	
#ifdef DEBUG
	system("pause");
#endif
}

int main()
{
	Read();
	
	Solve();
	
	Write();
	
#ifdef DEBUG
	fprintf(stderr, "MINESWEEPER RUN TIME: %.5lf\n", double(clock()) / double(CLOCKS_PER_SEC));
#endif
	
	return 0;
}

/*
TEST 0:
8 1
1 4
3 2
7 9
5 4
9 5
6 7
9 1
11 8
Answer: 34.408

TEST 1:
1 1
1 4
Answer: 6,283185307179586476925286766559


TEST 2:
2 1
1 4
3 2
Answer: 11,940039556671966672132041663397


TEST 3:
3 1
1 4
3 2
7 9
Answer: 24.984119856


TEST 4:
7 1
1 4
1 4
1 4
3 2
3 2
7 9
7 9
Answer: 24.984119856


TEST 5:
5 1
0 1
0 2
0 3
1 4
1 0
Answer: 


TEST 6:
9 1
0 1
0 2
0 3
1 1
1 2
1 3
2 1
2 2
2 3
Answer: 

*/
