/*
TASK: titanic
LANG: C++
*/

#include <algorithm>
#include <set>
using namespace std;


#define first					c
#define second					p


typedef struct point
{
	int X, Y;
	
	point(int x = 0, int y = 0) : X(x), Y(y) {}
	
	friend bool operator < (const point & a, const point & b)
	{
		if(a.X != b.X) return (a.X < b.X);
		
		return (a.Y < b.Y);
	}
};

typedef pair<int, point> PIP;


const int MAX_N = 1 << 10;
const int MAX_M = 1 << 10;
const int MAX_K = 3050;


const int dx[4] = {0, 0, 1, -1};
const int dy[4] = {1, -1, 0, 0};

const int UNDEF = - 1;
const int SET = 0;


int N, M, K;
int a[MAX_N][MAX_M], id[MAX_N][MAX_M];
point ans;
set<PIP> S;


void Read()
{
	scanf("%d %d", & N, & M);
	
	for(int i = 0; i < N; i ++)
		for(int j = 0; j < M; j ++)
			id[i][j] = UNDEF;
}
int ask(int x, int y)
{
	if(id[x][y] == SET) return a[x][y];
	
	K ++;
	
	if(MAX_K < K)
	{
		printf("%d %d\n", x, y);
		exit(0);
	}
	
	printf("0 %d %d\n", x, y);
	fflush(stdin);
	fflush(stdout);
	scanf("%d", & a[x][y]);
	fflush(stdin);
	fflush(stdout);
	
	id[x][y] = SET;
	
	return a[x][y];
}

void Solve_BF()
{
	for(int i = 0; i < N; i ++)
		for(int j = 0; j < M; j ++)
			ask(i, j);
	
	for(int x = 0; x < N; x ++)
	{
		for(int y = 0; y < M; y ++)
		{
		bool ok = true;
			
			for(int k = 0; k < 4; k ++)
			{
				int new_x = x + dx[k];
				int new_y = y + dy[k];
				
				if(!(0 <= new_x && new_x < N) || !(0 <= new_y && new_y < M)) continue;
				
				if(a[x][y] < a[new_x][new_y])
				{
					ok = false;
					
					break;
				}
			}
			
			if(ok)
			{
				ans = point(x, y);
				
				return;
			}
		}
	}
}

void Solve_Rand()
{
	srand(N * M);
	
	while(1)
	{
	bool ok = true;
		
		int x = rand() % N;
		int y = rand() % M;
		
		for(int i = 0; i < 4; i ++)
		{
			int new_x = x + dx[i];
			int new_y = y + dy[i];
			
			if(!(0 <= new_x && new_x < N) || !(0 <= new_y && new_y < M)) continue;
			
			if(ask(x, y) < ask(new_x, new_y))
			{
				ok = false;
				
				break;
			}
		}
		
		if(ok)
		{
			ans = point(x, y);
			
			return;
		}
	}
}

void Solve()
{
	if(N * M <= MAX_K) Solve_BF();
	else Solve_Rand();
}

void Write()
{
	printf("1 %d %d\n", ans.X, ans.Y);
}

int main()
{
	Read();
	
	Solve();
	
	Write();
	
//	fprintf(stderr, "Titanic RUN TIME: %.5lf\n", double(clock()) / double(CLOCKS_PER_SEC));
	
	
	return 0;
}
