/*
TASK:msweeper
LANG:C++
*/
#include <iostream>
#include <cstdio>
#include <cmath>
using namespace std;

#define EPS 1e-9
#define MAXN 10001

double totx, toty;

struct point {
 int x, y;
 double angle;
 point() { }
 point(int x, int y) : x(x), y(y) {}
 bool operator < (const point &o) const
 {
  return angle < o.angle;
 }
 void print() {
  printf("%d %d\n", x, y);
 }
};

int N, R;

point inp[MAXN];

double dist(point p1, point p2)
{
 return sqrt( (p1.x - p2.x) * (p1.x - p2.x) 
            + (p1.y - p2.y) * (p1.y - p2.y) );
}

int cross(point p1, point p2)
{
 return p1.x * p2.y - p2.x * p1.y;
}

int dot(point p1, point p2)
{
 return p1.x * p2.x + p1.y * p2.y;
}

double fuck(point p, point p1, point p2)
{
 point v1(p1.x - p.x, p1.y - p.y);
 point v2(p2.x - p.x, p2.y - p.y);
 
 double up = fabs(cross(v1, v2));
 double down = dist(p1, p) * dist(p2, p);
 
 double ang = asin(up / down);
 
 int help = dot(v1, v2); 
 if (help < 0) ang = M_PI - ang; 
 ang = M_PI - ang;
 
 double part = (ang / (2 * M_PI)) * (M_PI * 2. * R);
 
 return part; 
}

int hull[MAXN];

int main()
{
 scanf("%d%d", &N, &R);
 
 if (N == 1)
 {
  cout << 2. * M_PI * R << endl;
  return 0;
 }
 
 totx = 0.;
 toty = 0.;
 
 for (int i = 0; i < N; i++)
 {
  scanf("%d%d", &inp[i].x, &inp[i].y);
  totx += inp[i].x;
  toty += inp[i].y;
 }
  
 totx /= N;
 toty /= N;
 
 for (int i = 0; i < N; i++)
  inp[i].angle = atan2(inp[i].y - toty, inp[i].x - totx);
 
 sort(inp, inp + N);
 
 int hbeg = 0, hen = 2; 
 
 hull[0] = 0;
 hull[1] = 1;
 
 for (int i = 2; i < N; i++)
 {
  while (hen - hbeg >= 2)
  {
   point v1(inp[hull[hen - 2]].x - inp[hull[hen - 1]].x,
            inp[hull[hen - 2]].y - inp[hull[hen - 1]].y);
            
   point v2(inp[i].x - inp[hull[hen - 1]].x,
            inp[i].y - inp[hull[hen - 1]].y);
            
   if (cross(v1, v2) < 0) break;
   
   hen--;
  }
  hull[hen++] = i;
 }
 
 while (true)
 {
   point v1(inp[hull[hen - 2]].x - inp[hull[hen - 1]].x,
            inp[hull[hen - 2]].y - inp[hull[hen - 1]].y);
            
   point v2(inp[hbeg].x - inp[hull[hen - 1]].x,
            inp[hbeg].y - inp[hull[hen - 1]].y);
            
   if (cross(v1, v2) > 0) { hen--; continue; }
  
   point v3(inp[hull[hen - 1]].x - inp[hull[hbeg]].x,
            inp[hull[hen - 1]].y - inp[hull[hbeg]].y);
            
   point v4(inp[hbeg + 1].x - inp[hull[hbeg]].x,
            inp[hbeg + 1].y - inp[hull[hbeg]].y);
            
   if (cross(v3, v4) > 0) { hbeg++; continue; }
   
   break;
 }
 
 hull[hen++] = hull[hbeg];
 hull[hen] = hull[hbeg + 1];
 
 double ans = 0.;
 
 for (int i = hbeg; i < hen - 1; i++)
 {
  ans += dist(inp[hull[i]], inp[hull[i + 1]]);
  ans += fuck(inp[hull[i + 1]], inp[hull[i]], inp[hull[i + 2]]);
 }
 
 cout << ans << endl;
 
 return 0;
}
