/*
TASK:titanic
LANG:C++
*/
#include <iostream>
#include <cstdio>
using namespace std;

#define MAXQ 3050
#define MAXN 1000

int dr[] = {-1,1,0,0};
int dc[] = {0,0,-1,1};

int N, M;

int ask(int r, int c)
{
 int h = -1;
 printf("0 %d %d\n", r, c);
 scanf("%d", &h);
 return h;
}

int matr[MAXN][MAXN];

bool ok(int r, int c)
{
 for (int i = 0; i < 4; i++)
 {
  int nr = r + dr[i], nc = c + dc[i];
  if (nr < 0 || nc < 0 || nr >= N || nc >= M) continue;
  if (matr[nr][nc] == -1 || matr[nr][nc] > matr[r][c]) return false;
 }
 return true;
}

int main()
{
 memset(matr, -1, sizeof(matr));
 
 scanf("%d%d", &N, &M);
 
 if (N * M <= MAXQ)
 {
  for (int i = 0; i < N; i++)
   for (int j = 0; j < M; j++)
    matr[i][j] = ask(i, j);
    
  for (int i = 0; i < N; i++)
   for (int j = 0; j < M; j++)
    if (ok(i, j))
    {
     printf("1 %d %d\n", i, j);
     return 0;
    }
 }
 else
 {
  srand(time(NULL));
  for (int i = 0; i < MAXQ; i++)
  {
   int a = -1, b = -1;
   for (;;)
   {
    a = rand() % N; 
    b = rand() % M;
    if (matr[a][b] == -1) break;
   }
   
   matr[a][b] = ask(a, b);
   
   if (ok(a, b))
   {
    printf("1 %d %d\n", a, b);
    return 0;
   }
   
   for (int i = 0; i < 4; i++)
   {
    int nr = a + dr[i], nc = b + dc[i];
    if (nr < 0 || nc < 0 || nr >= N || nc >= M) continue;
    if (ok(nr, nc))
    {
     printf("1 %d %d\n", nr, nc);
     return 0;
    }
   }
   
  }
 }
   
 return 0;
}
