/*
TASK:msweeper
LANG:C++
*/
#include <cstdio>
#include <cmath>
#include <cstdlib>
#define NMAX 10000
typedef struct 
{
	int x,y;
}pnt;
#define cot(p) ((double)(p).x/(double)(p).y)
int comp(const pnt* a,const pnt* b)
{
	if(a->y==0&&b->y==0)
	{
		return a->x-b->x;
	}
	if(a->y==0)
	{
		return -1;
	}
	if(b->y==0)
	{
		return 1;
	}
	return (cot(*b)-cot(*a))>0?1:-1;
}
pnt g_stack[NMAX];
#define p_area(p1,p0,p2) ((p1.x-p0.x)*(p2.y-p0.y)-(p2.x-p0.x)*(p1.y-p0.y))
double Graham_scan(pnt* pts,int n)
{
	int i;
	int min=0;
	int g_size=2;
	double rez;
	pnt tmp;
	for(i=1;i<n;++i)
		if(pts[min].y>pts[i].y||(pts[min].y==pts[i].y&&pts[min].x>pts[i].x))
			min=i;
	if(min!=0)
	{
		tmp=pts[min];
		pts[min]=pts[0];
		pts[0]=tmp;
	}
//	tmp=pts[0];
	for(i=1;i<n;++i)
	{
		pts[i].x-=pts[0].x;
		pts[i].y-=pts[0].y;
	}
	pts[0].x=pts[0].y=0;
	qsort(pts+1,n-1,sizeof(pnt),(int(*)(const void*,const void*))comp);
	g_stack[0]=pts[0];
	g_stack[1]=pts[1];
	for(i=2;i<n;++i)
	{
		while(g_size>=2&&p_area(g_stack[g_size-2],g_stack[g_size-1],pts[i])>0)
			--g_size;
		g_stack[g_size++]=pts[i];
	}
	//for(i=0;i<g_size;++i)
//		printf("%d %d\n",g_stack[i].x+tmp.x,g_stack[i].y+tmp.y);
	rez=sqrt(( double)((g_stack[0].x-g_stack[g_size-1].x)*(g_stack[0].x-g_stack[g_size-1].x)+(g_stack[0].y-g_stack[g_size-1].y)*(g_stack[0].y-g_stack[g_size-1].y)));
	for(i=0;i<g_size-1;++i)
		rez+=sqrt(( double)((g_stack[i].x-g_stack[i+1].x)*(g_stack[i].x-g_stack[i+1].x)+(g_stack[i].y-g_stack[i+1].y)*(g_stack[i].y-g_stack[i+1].y)));
	return rez;	
}
pnt points[NMAX];
int main()
{
	double pi=acos(-1.0);
	int n,i;
	double R;
	scanf("%d %lf",&n,&R);
	for(i=0;i<n;++i)
		scanf("%d %d",&(points[i].x),&(points[i].y));
	printf("%.6lf\n",(double)Graham_scan(points,n)+2.0*pi*R);
	return 0;
}
