/*
TASK:msweeper
LANG:C++
*/
#include <iostream>
#include <vector>
#include <cmath>
#include <stack>
using namespace std;

const double eq=0.0001;
const double pi=3.1415926535997932384626433832795;
int n,r;

class point
{
      public:
             double x,y;
      point(double x1,double y1)
      {
      x=x1;
      y=y1;
      }
};

vector <point> points;

double miny=999999;
int start=0;

void tip(point o,int r)
{
     double angl=0;
     for(int i=0;i<=144;i++)
     {
      double x,y;
      x=o.x+sin(angl)*r;
      y=o.y+cos(angl)*r;
      points.push_back(point(x,y));
      if(y<miny){miny=y;start=points.size()-1;}
      angl+=(2*pi/144);
      }
}


void init()
{
     
     cin>>n>>r;
     for(int i=0;i<n;i++)
     {
             int x,y;
             cin>>x>>y;
             if(r!=0)
             tip(point(x,y),r);
             else
             {points.push_back(point(x,y));
              if(y<miny){miny=y;start=points.size()-1;}
             }
     }
}

struct cmp
{
       
       bool operator()(point a,point b)
       {
           if((points[0].y-a.y)<eq&&(points[0].y-a.y)>-eq&&(points[0].y-b.y)<eq&&(points[0].y-b.y)>-eq)
             return 1;           
           if((points[0].y-a.y)<eq&&(points[0].y-a.y)>-eq)
             {if(0>(points[0].x-b.x)/(points[0].y-b.y))return 1;
              return 0;
             }
           if((points[0].y-b.y)<eq&&(points[0].y-b.y)>-eq)
             {if((points[0].x-a.x)/(points[0].y-a.y)>0)return 1;
              return 0;
             }
           if((points[0].x-a.x)/(points[0].y-a.y)>(points[0].x-b.x)/(points[0].y-b.y))return 1;
           return 0;
           
       }  
};

bool ort(point a,point b,point c)
{
     double x1=a.x-b.x;
     double y1=a.y-b.y;
     double x2=a.x-c.x;
     double y2=a.y-c.y;
     if((x1*y2-x2*y1)>0)return 1;
     return 0;
     
}

double dis(int a,int b)
{
       double x=fabs(points[a].x-points[b].x);
       double y=fabs(points[a].y-points[b].y);
       return sqrt(x*x+y*y);
}

double sol=0;
void graham()
{
     
     stack <int> s;
     s.push(0);
     s.push(1);
     bool nort=ort(point(-999999,points[0].y),points[0],points[1]);
     for(int i=2;i<points.size();i++)
      {
             bool b=0;
             while(b==0)
             {int t=s.top();
              s.pop();
              if(s.empty()){s.push(i);b=1;}
              else
               {int ut=s.top();
                s.push(t);
                if(ort(points[ut],points[t],points[i])==nort)
                 {s.push(i);b=1;}
                else
                 s.pop();
                }
             }
      }
     
     int p1=s.top(),p2;
     s.pop();
     while(!s.empty())
     {
      p2=s.top();
      s.pop();
      sol+=dis(p1,p2);
      p1=p2;
     }
     
}       
int main()
{
    init();
    swap(points[start],points[0]);
    sort(points.begin()+1,points.end(),cmp());
    points.push_back(points[0]);
    graham();
    cout<<sol<<endl;
    return 0;
}
