/*
TASK:msweeper
LANG:C++
*/
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <algorithm>
#include <functional>
#include <utility>
#include <numeric>
#include <sstream>

using namespace std;

#define F(i,n) for (int i=0;i<n;i++)
#define Repi(n) F(i,n)
#define Repj(n) F(j,n)
#define Repk(n) F(k,n)
#define PI pair<int,int>
#define PD pair<double,double>
#define LL long long
#define ULL unsigned LL
#define UI unsigned int
#define x first
#define y second
#define MP make_pair
#define VI vector<int>
#define PB push_back
#define SZ size()
#define UI unsigned int
#define ALL(v) (v).begin(),(v).end()
#define PQ priority_queue
#define sqr(a) ((a)*(a))
#define sign(a) (((a)>0)-((a)<0))
#define ABS(a) (((a)>0)?(a):(-(a)))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define IT iterator
#define pause system("pause")
#define Time (double)clock()/CLOCKS_PER_SEC

const int MAXN=10100;
int N,M;
double R;
PI p[MAXN];
set<PI> used;

inline double dist1(const PI &A,const PI &B)
{
       return (double)sqr((double)A.x-(double)B.x)+(double)sqr((double)A.y-(double)B.y);
}

inline int cp(const PI &A,const PI &B,const PI &C)
{
       int dx1=B.x-A.x;
       int dy1=B.y-A.y;
       int dx2=C.x-A.x;
       int dy2=C.y-A.y;
       return dx1*dy2-dx2*dy1;
}

bool cmp(const PI &A,const PI &B)
{
     int CP=cp(p[0],A,B);
     return (CP==0)?(dist1(p[0],A)<dist1(p[0],B)):(CP>0);
}

void graham()
{
     int f=0;
     Repi(N)
      if (p[i]<p[f])
       f=i;
     swap(p[0],p[f]);
     sort(p+1,p+N,cmp);
     p[N]=p[0];
//     Repi(N+1)      cout<<" "<<i<<" -> "<<p[i].x<<" "<<p[i].y<<"\n";     cout<<"\n";
     
     M=2;
     for (int i=2;i<=N;i++)
      {
              //cout<<"                  cp "<<p[M-2].x<<" "<<p[M-2].y<<" , "<<p[M-1].x<<" "<<p[M-1].y<<" , "<<p[i].x<<" "<<p[i].y<<" = "<<cp(p[M-2],p[M-1],p[i])<<"\n";
              while (cp(p[M-2],p[M-1],p[i])<0) M--;//,cout<<" cp "<<p[M-1].x<<" "<<p[M-1].y<<" , "<<p[M].x<<" "<<p[M].y<<" , "<<p[i].x<<" "<<p[i].y<<" < 0 -> M="<<M<<"\n";
              //cout<<" p "<<M<<" = "<<p[i].x<<" "<<p[i].y<<"\n";
              swap(p[i],p[M++]);
      }
     M--;
    // cout<<"\n";

    // Repi(M+1)    cout<<" "<<i<<" -> "<<p[i].x<<" "<<p[i].y<<"\n";
}

int main()
{
    scanf("%d%lf",&N,&R);
    Repi(N)
     {
       scanf("%d%d",&p[i].x,&p[i].y);
       if (used.find(p[i])!=used.end())
        { i--; N--; } 
       else
        used.insert(p[i]);
     }
     
    graham();
    double ans=0;
    Repi(M)
     ans+=sqrt(dist1(p[i],p[i+1]));
    //cout<<" dist = "<<ans<<"\n";
    
    printf("%.6lf\n",ans+M_PI*2.*R);
    return 0;
}
