/*
TASK:msweeper
LANG:C++
*/

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <limits>
#include <cmath>

using namespace std;

typedef long long LL;

struct MS {
     int x, y;
};

double ans=0.0;
double MY_PI=3.1415926535897932384626433832795;
int n, r, X, Y, size;
MS P[1<<14], cHull[1<<14];

inline int ol(LL x1, LL y1, LL x2, LL y2, LL x3, LL y3) {
	 LL face=x1*(y2-y3)+x2*(y3-y1)+x3*(y1-y2);
	 if (face > 0)
	 	return 1;
 	 else if (face < 0)
 	    return -1;
     else 
  	    return 0;
}

bool angle(const MS &prev, const MS &next) {
	 int flag=ol(X, Y, next.x, next.y, prev.x, prev.y);
	 if (flag == 1)
	 	return false;
 	 if (flag == -1)
 	 	return true;
 	 if (flag == 0) {
	  	if (next.x == prev.x)
	  	   return prev.y < next.y;
	    else {
			 return prev.x < next.x;
	    }
     }	
}

inline int Dist(MS temp1, MS temp2) {
	 int x=temp1.x-temp2.x;
	 int y=temp1.y-temp2.y;
	 return x*x+y*y; 
}

void solve() {
	 sort(P+1, P+n, angle);
	 for (int i=0; i<3; ++i)
	 	 cHull[size++]=P[i];
	 for (int i=3; i<n; ++i) {
	 	 while (ol(cHull[size-2].x, cHull[size-2].y, cHull[size-1].x, cHull[size-1].y, P[i].x, P[i].y)!=1 && size>=2)
	 	 	--size;
 	 	 cHull[size++]=P[i];
	 }
	 for (int i=1; i<size; ++i)
	 	 ans+=sqrt((double)Dist(cHull[i-1], cHull[i]));
	 ans+=sqrt((double)Dist(cHull[0], cHull[size-1]));
	 ans+=(2*MY_PI*r);
	 printf("%.4lf\n", ans);
}

void input() {
	 int tempX, tempY, index;
	 tempX=INT_MAX;
	 tempY=INT_MAX;
	 index=INT_MAX;
	 
	 scanf("%d%d", &n, &r);
	 for (int i=0; i<n; ++i) {
	 	 scanf("%d%d", &P[i].x, &P[i].y);
	 	 if (P[i].y > tempY)
	 	 	continue;
 	 	 else if (P[i].y < tempY) {
		 	  tempY=P[i].y;
		 	  tempX=P[i].x;
		 	  index=i;
 	     }
 	     else if (P[i].y==tempY && P[i].x < tempX) {
 	     	  tempX=P[i].x;
 	     	  index=i;
         }
	 }
	 swap(P[0], P[index]);
	 X=tempX;
	 Y=tempY;
}

int main() {
	input();
	solve();
return 0;
}
