/*
TASK:boxes
LANG:C++
*/
#include <cstdio>
#include <vector>

using namespace std;

long n;

vector <long> unlocks[100001];

int next = 2;
long input[100001];
char used[100001] = {0}; //0-unused, 1-used, 2-unlocked

void unlock(int box)
{
  if (box == next)
  {
    for (++next; used[next] != 0; ++next);
  }
  if (used[box] != 2)
  {    
    used[box] = 2;
    for (int i = 0; i < unlocks[box].size(); ++i)
      unlock(unlocks[box][i]);
  }
}

void solve ()
{
    scanf ("%d", &n);  
    int a;
    for (int i = 1; i <= n; ++i)
    {    
      scanf ("%d", &a);
      input[i] = a;
      unlocks[a].push_back(i);
    }
    
    int cbox = 1, cycle_pin = 0, answ = 0;
    for (;next <= n;)
    {
      if (used[cbox] == 0)
      {
	if (next == cbox)
	{
	  for (++next; used[next] != 0; ++next);
	}
	used[cbox] = 1;      
	cbox = input[cbox];
      }
      if (used[cbox] == 1)
      {      
	unlock(cbox);
	cbox = next;
	++answ;
      }
      if (used[cbox] == 2)
      {
	printf ("error\n");
      }
    }
    printf ("%d", answ);
}

void clear()
{
  next = 2;
  for (int i = 0; i <= n; ++i) used[i] = 0;
  for (int i = 0; i <= n; ++i) unlocks[i].clear();
}

int main ()
{
  solve();
  printf (" ");
  clear();
  solve();
  printf ("\n");
  return 0;
}
