/*
TASK:msweeper
LANG:C++
*/
#include <cstdio>
#include <cmath>
#include <vector>

#define Pi acos(-1)

using namespace std;

struct pnt {double x, y;};

vector <int> wrap;

int n;
double R;
pnt P[10001];
char used[10001];

double cosine(pnt p1, pnt p2, pnt p3)
{
  double x1 = p1.x - p2.x;
  double y1 = p1.y - p2.y;
  double x2 = p3.x - p2.x;
  double y2 = p3.y - p2.y;
  
  double s = sqrt(x1*x1 + y1*y1) * sqrt(x2*x2 + y2*y2);  
  if (s == 0.0) return 1;
  
  double ret = (x1 * x2 + y2 * y1) / s;
  return ret;
}
double dist (pnt prev, pnt cur)
{
  double ret = sqrt ((prev.x - cur.x)*(prev.x - cur.x) + (prev.y - cur.y)*(prev.y - cur.y));
  return ret;
}

int main ()
{
  scanf ("%d %lf", &n, &R);
  int a, b;
  for (int i = 0; i < n; ++i)
  {
    scanf ("%d %d", &a, &b);
    P[i].x = a;
    P[i].y = b;
  }
  int mini = 0;
  for (int i = 0; i < n; ++i)  
    if (P[i].y < P[mini].y)
      mini = i;  
    
  int first = mini, prev = mini;
  pnt p0;
  p0.x = P[mini].x-1;
  p0.y = P[mini].y;
  
  int next;
  double mincos = 2, cos;
  for (int i = 0; i < n; ++i)  
    if (i != mini)
    {
      cos = cosine(p0, P[first], P[i]);
      if (cos < mincos)
      {
	mincos = cos;
	next = i;
      }
    }
  int cur = next;  
  double answ = 0;
  wrap.push_back(prev);
  answ += dist (P[prev], P[cur]);
    
  used[cur] = 1;	
    
  while (cur != first)
  {
    wrap.push_back(cur);
    mincos = 1;
    next = first;
    for (int i = 0; i < n; ++i)
    {
      if (used[i] == 0)
      {      
	cos = cosine(P[prev], P[cur], P[i]);
	if (cos < mincos)
	{
	  mincos = cos;
	  next = i;
	}
      }
    }
    used[next] = 1;
    answ += dist (P[cur], P[next]);
    prev = cur;
    cur = next;    
  }
  answ += 2 * Pi * R;
  printf ("%lf\n", answ);
  return 0;  
}

