/*
TASK: msweeper
LANG: C++
*/

#include <cstdio>
#include <algorithm>
#include <cmath>
#include <vector>

struct point {
	int x, y;
	
	point(){}
	point(int _x, int _y) : x(_x), y(_y) {}
	bool operator ==(point p) {
		return p.x == x && p.y == y;
	}
};

int n, r;
point points[16384];
std::vector <point> st;
point ld = point(30000, 30000);
int top;
double res;
double ang;

bool cmp(point a, point b) {
	return atan2(a.y - ld.y, a.x - ld.x) < atan2(b.y - ld.y, b.x - ld.x);
}

int prod(point a, point b, point c) {
	return (a.x*b.y + b.x*c.y + c.x*a.y - a.y*b.x - b.y*c.x - c.y*a.x);
}

double angle(point a, point b, point c) {
	double ang = fabs(atan2(a.y - b.y, a.x - b.x) - atan2(c.y - b.y, c.x - b.x));
	if(ang > M_PI)
		ang -= M_PI;
	return ang;
}

double dist(point a, point b) {
	return sqrt((a.y - b.y)*(a.y - b.y) + (a.x - b.x)*(a.x - b.x));
}

int main() {
	//freopen("msweeper.in", "r", stdin);
	
	scanf("%d%d", &n, &r);
	
	for(int i = 0; i < n; ++i) {
		scanf("%d%d", &points[i].x, &points[i].y);
		
		if(points[i].x < ld.x || (points[i].x == ld.x && points[i].y < ld.y)) {
			ld = points[i];
		}
	}
	
	std::sort(points, points + n, cmp);
	
	st.push_back(ld);
	st.push_back(points[0]);
	top = 1;
	
	for(int i = 1; i < n; ++i) {
		if(prod(st[top-1], st[top], points[i]) > 0) {
			st.push_back(points[i]);
			++top;
		} else {
			st.pop_back();
			st.push_back(points[i]);
		}
	}
	
	for(int i = 1; i <= top+1; ++i) {
		res += dist(st[i%(top+1)], st[i-1]);
		ang += (M_PI - angle(st[i-1], st[i%(top+1)], st[(i+1)%(top+1)]));
	}
	
	res = res + ang*r;
	
//	point a = point(0, 0);
//	point b = point(0, 1);
//	point c = point(-1, 1);
//	
//	printf("%lf\n", angle(a, b, c));
//
	printf("%lf\n", res);
		
	return 0;
}
