/*
TASK: msweeper
LANG: C++
*/

#include <cmath>
#include <cstdio>
#include <algorithm>

const double PI = 3.141592654;

const int MAXN = 10000 + 5;
const int FLOOR = 20000;

typedef struct { int x, y, num; } point;

point a[MAXN];

int n, r;
int obv[MAXN], k;

bool cmpx (point t, point p) {
    return t.x < p.x;
}

int D (point p0, point p1, point p2) {
    return (p1.x-p0.x)*(p2.y-p0.y) - (p1.y-p0.y)*(p2.x-p0.x);
}

bool cmp (point t, point p) {
    return D(a[0],t,p) >= 0;
}

void init (void) {
    scanf("%d%d", &n, &r);

    int i;
    for (i = 0; i < n; ++i) {
        scanf("%d%d", &a[i].x, &a[i].y);
        a[i].x += FLOOR; a[i].y += FLOOR;
        a[i].num = i;
        }

    for (i = 1; i < n; ++i)
        if (a[i].x < a[0].x) std::swap(a[0],a[i]);
        else if (a[i].x == a[0].x && a[i].y < a[0].y) std::swap(a[0],a[i]);

    std::sort(a+1,a+n,cmp);
    a[n] = a[0];
    k = 0;

    for (i = 2; i < n; ++i) if (D(a[0],a[1],a[i])) break;
    std::sort(a+1,a+i,cmpx);
    for (i = n-1; i > 1; --i) if (D(a[0],a[1],a[i])) break;
    std::sort(a+i+1,a+n,cmpx);
    /*
    puts("sorted:");
    for (i = 0; i <= n; ++i)
        printf("p%d(%d,%d)\n", a[i].num, a[i].x-FLOOR, a[i].y-FLOOR);
    puts("ans:");
    */
}

double dist (point t, point p) {
    return (double)sqrt((double)((t.x-p.x)*(t.x-p.x) + (t.y-p.y)*(t.y-p.y)));
}

void solve (void) {
    obv[k++] = 0; obv[k++] = 1;
    int i;
    for (i = 2; i <= n; ++i) {
        while (k >= 2 && D(a[obv[k-2]],a[obv[k-1]],a[i]) < 0) --k;
        obv[k++] = i;
    }
    /*
    for (i = 0; i < k; ++i)
        printf("p%d(%d,%d)\n", a[obv[i]].num, a[obv[i]].x-FLOOR, a[obv[i]].y-FLOOR);
    */
    double ans = 2*PI*r;
    for (i = 1; i < k; ++i) ans += dist(a[obv[i-1]],a[obv[i]]);
    printf("%lf\n", ans);
}

int main () {
    init();
    solve();

    return 0;
}

