/*
TASK: msweeper
LANG: C++
*/
#include <iostream>
#include <stack>
#include <cmath>
#define MAXN 10001
#define p pair< short, short >
#define pp pair< double, pair< short, short> >
using namespace std;

short N, R;
p A[MAXN];
pp B[MAXN];
double pi = 3.14159265358979;

int cross(p p1, p p2, p p3) // p2p1 x p2p3
{
    p x(p1.first - p2.first, p1.second - p2.second);
    p y(p3.first - p2.first, p3.second - p2.second);
    
    return (x.first * y.second - x.second * y.first);
}

int main()
{
    short i, j = 0, k;
    
    scanf("%d%d", &N, &R);
    for (i=0;i < N;i++)
    {
        scanf("%d%d", &A[i].first, &A[i].second);
        if (A[i].second < A[j].second || (A[i].second == A[j].second && A[i].first < A[j].first))
         j = i;
    }
    
    int cnt = 0;
    for (i=0;i < N;i++)
     if (i != j)
     {
         B[cnt].first = atan2(A[i].second - A[j].second, A[i].first - A[j].first);
         B[cnt].second = A[i];
         cnt++;
     }
    
    sort(B, B + N - 1);
    p chull[MAXN];
    chull[0] = A[j];
    chull[1] = B[0].second;
    i = 0; j = 1;
    for (k=1;k < N-1;k++)
    {
        if (cross(chull[i], chull[j], B[k].second) > 0)
        {
            k--; // k remains k
            i--;
            j--;
        }
        else
        {
            chull[j+1] = B[k].second;
            i++;
            j++;
        }
    }
    
    if (cross(chull[i], chull[j], chull[0]) > 0) { i--; j--; }
    if (cross(chull[j], chull[0], chull[1]) > 0) { i--; j--; }
    
    double ans = 0;
    for (i=0; i < j;i++)
     ans += sqrt(pow((double)(chull[i+1].first - chull[i].first),2) + pow((double)(chull[i+1].second - chull[i].second),2));
    ans += sqrt(pow((double)(chull[i].first - chull[0].first),2) + pow((double)(chull[i].second - chull[0].second),2));
    ans += 2 * pi * R;
    
    cout << ans << endl;
    return 0;
}
