
/*
TASK: diamonds
LANG: C++
*/

#include <cstdio>
#include <cstring>
using namespace std;

const int MAX_L = 100 + 5;
const int MAX_M = 100 + 5;
const int MAX_N = 100 + 5;

int L, M, N;
int am[MAX_N][MAX_M][MAX_L];
int dp[MAX_N][MAX_M][MAX_L];

void read() {
    scanf("%d %d %d", &L, &M, &N);
    for (int i = 0; i < N; ++i)
        for (int j = 0; j < M; ++j)
            for (int k = 0; k < L; ++k) {
                scanf("%d", &am[i][j][k]);
            }
}

inline int getSum(int at, int x1, int y1, int x2, int y2) {
    return dp[at][x2][y2] + dp[at][x1][y1] - dp[at][x2][y1] - dp[at][x1][y2];
}

void solve() { // O(Q)
    for (int i = 1; i <= N; ++i) {
        static int new_dp[MAX_M][MAX_L];
        memset(new_dp, 0, sizeof(new_dp));
        for (int j = 1; j <= M; ++j)
            for (int k = 1; k <= L; ++k)
                new_dp[j][k] = new_dp[j - 1][k] + new_dp[j][k - 1] - new_dp[j - 1][k - 1] + am[i - 1][j - 1][k - 1];
        for (int j = 1; j <= M; ++j)
            for (int k = 1; k <= L; ++k) {
                dp[i][j][k] = dp[i - 1][j][k] + new_dp[j][k];
            }
    }

    int x1, y1, z1, x2, y2, z2;
    while (scanf("%d %d %d %d %d %d", &x1, &y1, &z1, &x2, &y2, &z2) > 0) {
        int sum = -dp[z1][y1][x1] + dp[z1][y1][x2] + dp[z1][y2][x1] - dp[z1][y2][x2] + dp[z2][y1][x1] - dp[z2][y1][x2] - dp[z2][y2][x1] + dp[z2][y2][x2];
       //for (int z = z1; z < z2; ++z) { // N
        //    sum += getSum(z, y2, x2, y1, x1);
        //}
        printf("%d\n", sum);
    }
}

int main() {
    read();
    solve();
    return 0;
}
