
/*
TASK: frogs
LANG: C++
*/

#include <cstdio>
#include <algorithm>
using namespace std;

const int MAX_N = 1000000 + 5;
const int INF = 2000000000;

struct frog {
    int height;
    int pos;

    inline bool operator <(const frog &rhs) const {
        return height < rhs.height;
    }
};

int N;
int h[MAX_N];
int jumps[MAX_N];

void read() {
    scanf("%d", &N);
    for (int i = 0; i < N; ++i)
        scanf("%d", &h[i]);
    for (int i = 0; i < N; ++i)
        scanf("%d", &jumps[i]);
    jumps[N] = 100;
    h[N++] = INF;
}

void solve() { // O(n)
    static int stk[MAX_N];
    int sp = 0;
    for (int i = N - 1; i >= 0; --i) {
//        printf("i = %d", i);
//        for (int j = 0; j < sp; ++j) printf(" %d ", h[stk[j]]);
//        puts("");
        while (sp > 0 && h[i] >= h[stk[sp - 1]])
            --sp;
        if (jumps[i] == 0) {
            jumps[i] = h[i];
        } else if (jumps[i] > sp) {
            jumps[i] = -1;
        } else {
//            printf("jumps[%d] = %d\n", i, stk[sp - jumps[i]]);
            jumps[i] = h[stk[sp - jumps[i]]];
            if (jumps[i] == INF)
                jumps[i] = -1;
        }
        stk[sp++] = i;
    }
    for (int i = 0; i < N - 1; ++i) {
        if (i > 0)
            printf(" ");
        printf("%d", jumps[i]);
    }
    puts("");
}

int main() {
    read();
    solve();
    return 0;
}
