/*
TASK: diamonds
LANG: C++
*/

#include <cstdio>

#define ull unsigned long long

int tree[128][128][128];

void add(int pos1, int pos2, int pos3, int val) {
    for(int i = pos1; i < 128; i += i&(-i)) {
        for(int j = pos2; j < 128; j += j&(-j)) {
            for(int k = pos3; k < 128; k += k&(-k)) {
                tree[i][j][k] += val;
            }
        }
    }
}
int query(int pos1, int pos2, int pos3) {
    int res = 0;
    for(int i = pos1; i > 0; i -= i&(-i)) {
        for(int j = pos2; j > 0; j -= j&(-j)) {
            for(int k = pos3; k > 0; k -= k&(-k)) {
                res += tree[i][j][k];
            }
        }
    }
    return res;
}
int query(int x1, int x2, int y1, int y2, int z1, int z2) {
    ull res = 0;

    res += query(x2, y2, z2);
    //printf("add %d\n", query(x2, y2, z2));

    res -= query(x1, y2, z2);
    //printf("sub %d\n", query(x1, y2, z2));

    res -= query(x2, y1, z2);
    //printf("sub %d\n", query(x2, y1, z2));
    res += query(x1, y1, z2);
    //printf("add %d\n", query(x1, y1, z2));

    res -= query(x2, y2, z1);
    //printf("sub %d\n", query(x2, y2, z1));
    res += query(x1, y2, z1);
    //printf("add %d\n", query(x1, y2, z1));
    //res -= query(x2, y1, z1);
    //printf("sub %d\n", query(x2, y1, z1));
    res += query(x1, y1, z1);
    //printf("add %d\n", query(x1, y1, z1));

    //printf("%d\n", res);
    return (int)res;
}

int main() {
    int w, h, d, cval;
    scanf("%d%d%d\n", &w, &h, &d);

    for(int z = 1; z <= d; ++z) {
        for(int y = 1; y <= h; ++y) {
            for(int x = 1; x <= w; ++x) {
                scanf("%d\n", &cval);
                add(x, y, z, cval);
            }
        }
    }
    while(!feof(stdin)) {
        int x1, x2, y1, y2, z1, z2;
        scanf("%d%d%d%d%d%d\n", &x1, &y1, &z1, &x2, &y2, &z2);
        printf("%d\n", query(x1, x2, y1, y2, z1, z2));
    }
    return 0;
}
