/*
TASK: frogs
LANG: C++
*/

#include <cstdio>
#include <ctime>
#include <cstring>
#include <climits>

inline int max(int a, int b) {
	return a > b ? a : b;
}


int n;
int h[1024*1024]; // 4M
int j[1024*1024]; // 4M
int max32[1024*1024/32]; // 128K
int max128[1024*1024/128]; // 16K
int max1K[1024*1024/1024]; // 1K
int max65K[1024*1024/65536]; // 16

int next_pos(int start, int min) {
	for(int i = start; i < n; ++i) {
	    while(i % 65536 == 0 && i < n && max65K[i/65536] <= min) i += 65536;
	    while(i % 1024 == 0  && i < n && max1K[i/1024]   <= min) i += 1024;
	    while(i % 128 == 0   && i < n && max128[i/128]   <= min) i += 128;
	    while(i % 32 == 0    && i < n && max32[i/32]     <= min) i += 32;

		if(h[i] > min)
			return i;
	}
	return -1;
}

int ac[1024*1024]; // 4M

void query(int pos) {
    int cpos = pos, cj = 0;
    while(cj < j[pos]) {

        if(ac[cpos] != INT_MIN) {
            if(j[cpos] <= j[pos]-cj) {
                //printf("opt %d by frog %d\n", pos, cpos);

                cj += j[cpos];
                cpos = ac[cpos];
                if(cpos == -1)
                    break;
                continue;
            }
        }

    	cpos = next_pos(cpos, h[cpos]);
    	if(cpos == -1)
			break;
		++cj;
    }
    if(j[pos]-cj > 0) {
        ac[pos] = -1;
    }
    ac[pos] = cpos;
}

int main() {
    for(int i = 0; i  < 1024*1024; ++i) {
        ac[i] = INT_MIN;
    }
	//long start = clock();

    scanf("%d", &n);
    for(int i = 0; i < n; ++i) {
        scanf("%d", &h[i]);
        max32[i/32] = max(max32[i/32], h[i]);
        max128[i/128] = max(max128[i/128], h[i]);
        max1K[i/1024] = max(max1K[i/1024], h[i]);
        max65K[i/65536] = max(max65K[i/65536], h[i]);
    }
    for(int i = 0; i < n; ++i)
        scanf("%d", j+i);
    for(int i = n-1; i >= 0; --i) {
    	query(i);
    }
    for(int i = 0; i < n; ++i) {
        printf("%s%d", i > 0 ? " " : "", ac[i] >= 0 ? h[ac[i]] : -1);
    }
    printf("\n");
    //printf("%lf\n", (double)(clock()-start)/CLOCKS_PER_SEC);
    return 0;
}
