/*
TASK:frogs
LANG:C++
*/
#include <iostream>
#include <cstdio>
#include <set>
using namespace std;

#define MAXN 100001

struct frog {
 int pos, stH, jump;
 frog() { }
 frog(int stH, int jump) : stH(stH), jump(jump) { }
 bool operator < (const frog &o) const
 {
  if (stH != o.stH) return stH < o.stH;
  if (pos != o.pos) return pos < o.pos;
  return jump < o.jump;
 }
} inp[MAXN];

int N;

int h[MAXN], maxj[MAXN];

int ans[MAXN];

int save[MAXN], next[MAXN];

set<int> work;

int main()
{
 scanf("%d", &N);
 
 for (int i = 0; i < N; i++)
  scanf("%d", &h[i]);
  
 for (int i = 0; i < N; i++) 
  scanf("%d", &maxj[i]);
 
 for (int i = 0; i < N; i++)
 {
  inp[i].pos = i;
  inp[i].stH = h[i];
  inp[i].jump = maxj[i];
 }
 
 sort(inp, inp + N);
 
 memset(ans, 0, sizeof(ans));
 
 work.insert(inp[N - 1].pos);
 
 save[inp[N - 1].pos] = N - 1; 
 ans[inp[N - 1].pos] = -1;
 
 memset(next, -1, sizeof(next)); 
 
 for (int i = N - 2; i >= 0; i--)
 {
  save[inp[i].pos] = i;
  
  set<int>::iterator p = work.upper_bound(inp[i].pos);
  if (p == work.end())
  {
   ans[inp[i].pos] = -1;
   work.insert(inp[i].pos);
   continue;
  }
  
  int curj = inp[i].jump - 1;
  
  int thepos = save[*p];
  
  while (curj > 0 && next[thepos] != -1)  
  {
   curj--;
   thepos = next[thepos];
  }
  
  next[i] = save[*p];
  
  if (curj > 0 && next[thepos] == -1) 
   ans[inp[i].pos] = -1;
  else
   ans[inp[i].pos] = inp[thepos].stH;
  
  work.insert(inp[i].pos);
 }
  
 for (int i = 0; i < N - 1; i++)
  printf("%d ", ans[i]); 
  
 printf("%d\n", ans[N - 1]);
   
 return 0;
}
